
/*  A Bison parser, made from parser/marde.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse deparse
#define yylex delex
#define yyerror deerror
#define yylval delval
#define yychar dechar
#define yydebug dedebug
#define yynerrs denerrs
#define	UNTIL	257
#define	RELEASE	258
#define	IMPL	259
#define	EQUIV	260
#define	OR	261
#define	XOR	262
#define	AND	263
#define	FINALLY	264
#define	GLOBALLY	265
#define	NEXT	266
#define	NE	267
#define	EQ	268
#define	GE	269
#define	LE	270
#define	ROL	271
#define	ROR	272
#define	IS	273
#define	CARDINALITY	274
#define	MIN	275
#define	MAX	276
#define	MAP	277
#define	EQUALS	278
#define	SUBSET	279
#define	MINUS	280
#define	UNION	281
#define	INTERSECT	282
#define	ATOM	283
#define	NUMBER	284
#define	STATE	285
#define	COMP	286
#define	CHARACTER	287
#define	NAME	288
#define	TRUE_	289
#define	FALSE_	290
#define	UNDEFINED	291
#define	FATAL	292
#define	EMPTY	293
#define	PLACE	294
#define	MODEL	295
#define	GRAPH	296
#define	LSTS	297
#define	UNFOLD	298
#define	BREADTH	299
#define	DEPTH	300
#define	STRONG	301
#define	PATH	302
#define	TERMINAL	303
#define	COMPONENTS	304
#define	CD	305
#define	TRANSLATOR	306
#define	COMPILEDIR	307
#define	VISUAL	308
#define	DUMP	309
#define	EVAL	310
#define	HIDE	311
#define	SHOW	312
#define	SUCC	313
#define	PRED	314
#define	GO	315
#define	STATS	316
#define	TIME	317
#define	HELP	318
#define	FUNCTION	319
#define	EXIT	320

#line 3 "parser/marde.y"

#ifdef __WIN32
# undef __STRICT_ANSI__
# include <io.h>
# undef chdir
# define chdir(path) _chdir (path)
#else // WIN32
# include <alloca.h>
#endif // __WIN32
#include <unistd.h> // for chdir(2)
#include <cstdlib> // for getenv(3)

#include "util.h"
#include "StringBuffer.h"
#include "VariableStackMap.h"
#include "Printer.h"

#include "allExpressions.h"
#include "ExpressionSet.h"

#include "Transition.h"
#include "Place.h"
#include "Net.h"
#include "GlobalMarking.h"
#include "VariableDefinition.h"
#include "VariableSet.h"
#include "Function.h"

#include "Quantifier.h"

#include "typedefs.h"
#include "allTypes.h"
#include "allValues.h"
#include "Valuation.h"

# include <set>
# include <map>
# include <list>
# include <stack>

# ifndef NDEBUG
#  define ASSERT1(x) x
# else
#  define ASSERT1(x)
# endif

  /** @file marde.y
   * Parser for the query language
   */

  /** flag: exiting */
  bool exiting = false;
  /** warning flag (true=print warnings) */
  extern bool dewarnings;
  /** Maximum range size of quantifications */
  extern card_t maxRange;
  /** Translator for property automata */
  extern char* translator;
#ifdef EXPR_COMPILE
  /** name of the compilation directory (NULL=don't compile) */
  extern char* compiledir;
#endif // EXPR_COMPILE

  /** read a command line */
  const char* deline ();
  /** reset the parser and the lexical analyzer */
  void dereset ();
  /** reset the lexical analyzer */
  extern void delexreset ();

  /** lexical analyzer function
   * @return		a terminal symbol, and set yylval to its semantic value
   */
  extern int delex ();

  /** flag: expecting a command keyword */
  bool command = true;
  /** The state being examined */
  static card_t currentState = CARD_T_MAX;
  /** Visualization level */
  static card_t visual;
  /** Flag: hide/reveal */
  static bool hide;

  /** The printer object */
  extern class Printer thePrinter;
  /** The Petri Net */
  extern class Net* net;
  /** Parameters of the function that is currently being processed */
  static class VariableDefinition** currentParameters = NULL;
  /** Arity of the function that is currently being processed */
  static unsigned currentArity = 0;
  /** Function being invoked */
  static std::stack< class Function*, std::list<class Function*> >
    functionStack;
  /** The context transition */
  static class Transition* currentContextTransition = NULL;
  /** The type definition that is currently being processed */
  static const class Type* currentType = NULL;
  /** The context type of currentType (StructType or VectorType or NULL) */
  static const class Type* currentContextType = NULL;
  /** Struct or vector component number currently being parsed */
  static card_t currentComponent;
  /** Type context */
  struct TypeContext
  {
    /** Context type (@see currentContextType), may be NULL */
    const class Type* context;
    /** Component type (@see currentContext) */
    const class Type* component;
    /** Number of current component (@see currentComponent)
     * , meaningless if context==NULL */
    card_t numComponent;
  };
  /** Stack of types, used e.g. when parsing quantifier conditions */
  static std::stack< struct TypeContext, std::list<struct TypeContext> >
    typeStack;

  /** Flag: has an empty list component been parsed? */
  static bool emptyParsed = false;

  typedef std::pair<const class Type*,card_t> StructLevel;
  /** Stack for parsing structs and vectors */
  static std::stack< StructLevel, std::list<StructLevel> > structLevels;

  /** Open a model
   * @param filename	name of the net to be analyzed
   * @param graphfile	base name for the reachability graph files
   * @param regen	flag: regenerate the graph files
   * @return		false on error, true otherwise
   */
  extern bool model (const char* filename, const char* graphfile, bool regen);

  /** Generate an LSTS of the model when generating the state space
   * @param filebase	base file name (NULL=disable LSTS generation)
   */
  extern void lsts (const char* filebase);

  /** Unfold the model
   * @param ffilename	output format and file name (NULL=default,stdout)
   */
  extern void unfold (const char* ffilename);

  /** Dump the syntax tree of the model
   * @param visual	visualization level
   */
  extern void dump (card_t visual);

  /** Perform exhaustive reachability analysis
   * @param state	state to start the analysis with
   * @param breadth	flag: go breadth-first instead of depth-first
   */
  extern void analyze (card_t state, bool breadth);

  /** Check if a state number exists
   * @param state	the state
   * @return		true if the state exists
   */
  extern bool isState (card_t state);

  /** Show a state
   * @param state	the state
   * @param visual	visualization level
   */
  extern void show (card_t state, card_t visual);

  /** Show a path specified as a state list
   * @param sl		the state list
   * @param visual	visualization level
   */
  extern void show (const card_t* states, card_t visual);

  /** Show the successors of a state
   * @param state	the state
   * @param visual	visualization level
   */
  extern void succ (card_t state, card_t visual);

  /** Show the predecessors of a state
   * @param state	the state
   * @param visual	visualization level
   */
  extern void pred (card_t state, card_t visual);

  /** Display statistics */
  extern void stats (void);

  /** Display execution times */
  extern void showtimes (void);

  /** Compute strongly connected components
   * @param state	state in which to start the search
   * @param cond	condition for the states to be included in the search
   */
  extern void strong (card_t state, class Expression* cond);
  /** Display non-trivial terminal strongly connected components */
  extern void terminal ();
  /** Display all strongly connected components
   * @param visual	visualization level
   */
  extern void allcomps (card_t visual);
  /** Show the nodes of a strongly connected component fulfilling a condition
   * @param comp	the component
   * @param cond	the condition
   * @param visual	visualization level
   */
  extern void comp_show (card_t comp,
			 class Expression* cond,
			 card_t visual);
  /** Show the successors of a strongly connected component
   * @param comp	the component
   * @param visual	visualization level
   */
  extern void comp_succ (card_t comp, card_t visual);
  /** Show the predecessors of a strongly connected component
   * @param comp	the component
   * @param visual	visualization level
   */
  extern void comp_pred (card_t comp, card_t visual);
  /** Show the shortest path from a state to a strongly connected component
   * @param state	the state
   * @param comp	the component
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_sc (card_t state, card_t comp,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a strongly connected component to a state
   * @param comp	the component
   * @param state	the state
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_cs (card_t comp, card_t state,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a state to a state
   * @param state	the source state
   * @param dest	the target state
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_ss (card_t state, card_t dest,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a state to a state where a condition holds
   * @param state	the source state
   * @param cond	the condition
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_se (card_t state, class Expression& cond,
		       class Expression* pathc,
		       card_t visual);
  /** Show the shortest path from a state where a condition holds to a state
   * @param state	the target state
   * @param cond	the condition
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void rpath_se (card_t state, class Expression& cond,
			class Expression* pathc,
			card_t visual);
  /** Show the shortest path from a state to a loop state, plus the loop
   * @param state	the source state
   * @param loop	amount and number of states in the loop
   * @param pathc	path condition (must hold in every state on the path)
   * @param visual	visualization level
   */
  extern void path_sl (card_t state,
		       const card_t* loop,
		       class Expression* pathc,
		       card_t visual);

  /** Evaluate a formula in the current state
   * @param state	state in which to evaluate the formula
   * @param expr	formula to be evaluated
   * @param visual	visualization level for counterexample
   */
  extern void eval (card_t state, class Expression* expr, card_t visual);

  /** Display a short help message */
  static void help (void);

  /** Determine whether a model has been loaded
   * @return		true if a model has been loaded
   */
  static bool isNet (void);

  /** Display a type name in an error message
   * @param type	type to be displayed
   */
  static void printType (const class Type& type);

  /** Push the type context on structLevels
   * @param type	new type context
   */
  static void pushTypeContext (const class Type* type);
  /** Restore the type context from structLevels */
  static void popTypeContext ();

  /** Get the parameter of the currently parsed function by name
   * @param name	name of the parameter
   * @return		the corresponding VariableDefinition, or NULL
   */
  static const class VariableDefinition* getParameter (char* name);

  /** Add a parameter to the function definition being parsed
   * @param type	type of the parameter
   * @param name	name of the parameter
   */
  static void addParameter (const class Type* type, char* name);

  /** Get a Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getFunction (const char* name);

  /** Get a zero-arity Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getConstantFunction (const char* name);

  /** Get a Constant by name
   * @param name	the constant name
   * @return		a Constant object
   */
  static const class Constant* getConstant (const char* name);

  /** Get a state proposition by name
   * @param name	the proposition name
   * @return		the corresponding proposition, or NULL
   */
  static const class Expression* getProposition (char* name);

  /** Resolve a name to a constant or variable
   * @param name	the name
   * @return		the resolved expression, or NULL
   */
  static class Expression* resolveName (char* name);

  /** Ensure that the formula is a set-valued expression
   * @param expr	formula to be checked
   * @param type	expected type of the formula
   * @return		expr, pointer to a Marking object, or NULL
   */
  static class Expression* ensureSet (class Expression* expr,
				      const class Type* type = 0);

  /** Ensure that the formula is a marking expression, converting if needed
   * @param expr	formula to be checked
   * @param type	expected type of the expression
   * @return		pointer to a Marking object, or NULL
   */
  static class Marking* ensureMarking (class Expression* expr,
				       const class Type* type);

  /** Ensure that the formula is not a marking expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* noMarking (class Expression* expr);

  /** Ensure that the formula is a basic expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureExpr (class Expression* expr);

  /** Ensure that the formula is a boolean expression
   * @param expr	formula to be checked
   * @param undefined	flag: allow the formula to be Undefined
   * @return		expr or NULL
   */
  static class Expression* ensureBool (class Expression* expr,
				       bool undefined = false);

  /** Ensure that the formula is a signed integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureInt (class Expression* expr);

  /** Ensure that the formula is an unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureCard (class Expression* expr);

  /** Ensure that the formula is a signed or unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureIntCard (class Expression* expr);

  /** Ensure that the formula is a buffer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureBuffer (class Expression* expr);

  /** Ensure that the formula is a basic expression of ordered type
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureOrdered (class Expression* expr);

  /** Convert an integer to an enumeration value if possible
   * @param type	type of the enumeration value
   * @param value	numerical value to be converted to the enumeration type
   * @return		a constant having the enumeration value or NULL
   */
  static class Expression* enumValue (const class EnumType& type,
				      card_t value);

  /** Ensure that a named component matches a struct being parsed
   * @param name	name of the component
   * @param expr	initialization expression for the component
   * @return		expr or NULL
   */
  static class Expression* namedComponent (char* name, class Expression* expr);

  /** Begin parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   */
  static void beginQuantifier (char* name, const class Type* type);

  /** Continue parsing a quantifier expression
   *  (after parsing an optional condition)
   * @param type	type of the quantifier variable
   */
  static void continueQuantifier (ASSERT1 (const class Type* type));

  /** End parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   * @param condition	quantification condition (optional)
   * @param kind	quantification kind (1=sum, 2=forall, 3=exists)
   * @param expr	marking expression
   * @return		expr augmented with the quantifier, or NULL if failed
   */
  static class Expression* endQuantifier (char* name, const class Type* type,
					  class Expression* condition,
					  unsigned kind,
					  class Expression* expr);

  /** Declare a quantified variable
   * @param prefix	prefix of the quantified variable
   * @param quant	name of the quantifier variable
   * @param pred	flag: use a predecessor value of the quantifier
   * @return		a quantified variable, or NULL if failed
   */
  static class Expression* quantifierVariable (char* prefix,
					       char* quant,
					       bool pred);

  /** Try to make expr compatible with type if expr is a Constant
   * @param expr	expression to be made compatible
   * @param type	type to be made compatible with
   * @param casting	flag: typecasting in progress (suppress a warning)
   * @return		true if expr is not a Constant or
   *			if the conversion succeeded
   */
  static bool makeCompatible (class Expression*& expr,
			      const class Type& type,
			      bool casting = false);

  /** Determine whether an expression is compatible with a type
   * @param expr	expression to be checked
   * @param type	the type
   * @return		true if the expression is compatible with the type
   */
  static bool isCompatible (class Expression*& expr,
			    const class Type* type);

  /** Determine whether an expression is compatible with
   * the struct component being parsed
   * @param expr	expression to be checked
   * @param s		the struct whose current component is considered
   * @return		true if the expression is compatible with the struct
   */
  static bool isCompatible (class Expression*& expr,
			    const class StructExpression& s);

  /** Ensure that the type is ordered
   * @param type	type to be checked
   * @return		true if the type is ordered
   */
  static bool isOrdered (const class Type& type);

  /** Check a valuation
   * @param v		valuation to be checked
   * @return		true if the valuation is OK
   */
  static bool check (const class Valuation& v);

  /** Perform constant folding
   * @param expr	expression to be folded
   * @return		expr or a new Constant, or NULL in case of error
   */
  static class Expression* fold (class Expression* expr);

  /** Define a function
   * @param type	type of the function
   * @param name	name of the function
   * @param expr	body of the function
   */
  static void defun (const class Type* type,
		     char* name,
		     class Expression* expr);

  /** Create a RelopExpression or optimize it
   * @param equal	flag: equality comparison (instead of less-than)
   * @param left	left-hand-side of RelopExpression
   * @param right	right-hand-side of RelopExpression
   * @return		RelopExpression or a Boolean constant
   */
  static class Expression* newRelopExpression (bool equal,
					       class Expression* left,
					       class Expression* right);

  /** Create a BinopExpression
   * @param op		operator
   * @param left	left-hand-side of BinopExpression
   * @param right	right-hand-side of BinopExpression
   * @return		BinopExpression
   */
  static class Expression* newBinopExpression (enum BinopExpression::Op op,
					       class Expression* left,
					       class Expression* right);

  /** Create a NotExpression or optimize it
   * @param expr	an expression
   * @return		a negation of the expression
   */
  static class Expression* newNotExpression (class Expression* expr);

  /** Create a BooleanBinop or optimize it
   * @param conj	flag: conjunction (instead of disjunction)
   * @param left	left-hand-side of BooleanBinop
   * @param right	right-hand-side of BooleanBinop
   * @return		left, right, Boolean constant, or a BooleanBinop
   */
  static class Expression* newBooleanBinop (bool conj,
					    class Expression* left,
					    class Expression* right);

  /** Create a SetExpression or optimize it
   * @param op		operator
   * @param left	left-hand-side of SetExpression
   * @param right	right-hand-side of SetExpression
   */
  static class Expression* newSetExpression (enum SetExpression::Op op,
					     class Expression* left,
					     class Expression* right);

  /** Create a CardinalityExpression or optimize it
   * @param op		operator
   * @param expr	the multi-set expression
   */
  static class Expression* newCardinalityExpression
    (enum CardinalityExpression::Op op,
     class Expression* expr);

  /** Create a BufferUnop from a buffer expression
   * @param op		operator
   * @param expr	the buffer expression
   * @return		a BufferUnop object, or NULL
   */
  static class Expression* newBufferUnop (enum BufferUnop::Op op,
					  class Expression* expr);

  /** Variable stack map to be used with variable scoping */
  static class VariableStackMap currentVariables;

  /** Set of subexpressions for common subexpression elimination */
  static class ExpressionSet currentExpressions;

  /** Eliminate common subexpressions
   * @param expr	expression to be searched in currentExpressions
   * @return		expr or an equivalent expression
   */
  inline static class Expression* CSE (class Expression* expr) {
    return expr ? currentExpressions.insert (expr) : NULL;
  }

  /**
   * generic compiler warning reporting function
   * @param s		warning message
   */
  extern void dewarn (const char* s);

  /**
   * generic parser error reporting function
   * @param s		error message
   */
  extern void deerror (const char* s);

#line 606 "parser/marde.y"
typedef union{
  card_t i;
  card_t* ia;
  char_t c;
  char* s;
  class Expression* expr;
  class ExpressionList* exprList;
  const class Place* place;
  class Marking* marking;
  const class Type* type;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		344
#define	YYFLAG		-32768
#define	YYNTBASE	92

#define YYTRANSLATE(x) ((unsigned)(x) <= 320 ? yytranslate[x] : 150)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    34,     2,    31,     2,    30,    17,     2,    47,
    88,    28,    26,    86,    27,    45,    29,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     4,    85,    22,
    87,    23,     3,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    46,     2,    91,    16,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    89,    15,    90,    33,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    18,    19,    20,    21,
    24,    25,    32,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     5,     6,    10,    12,    16,    19,    22,
    25,    27,    29,    32,    36,    39,    42,    46,    50,    55,
    58,    62,    66,    70,    74,    78,    80,    82,    84,    86,
    88,    90,    93,    95,    97,   100,   103,   105,   108,   109,
   112,   115,   118,   121,   124,   127,   130,   133,   136,   139,
   142,   144,   147,   150,   154,   158,   160,   163,   166,   168,
   169,   172,   173,   176,   179,   182,   183,   186,   187,   189,
   192,   196,   199,   204,   207,   210,   216,   222,   227,   232,
   238,   244,   245,   249,   251,   253,   255,   256,   258,   259,
   261,   263,   265,   267,   269,   270,   276,   277,   285,   288,
   293,   296,   297,   299,   301,   302,   307,   308,   312,   313,
   315,   318,   322,   324,   328,   329,   331,   333,   335,   337,
   339,   341,   343,   346,   347,   353,   355,   357,   359,   361,
   363,   365,   367,   369,   370,   375,   376,   381,   382,   387,
   391,   394,   398,   402,   406,   410,   414,   418,   422,   426,
   430,   434,   438,   441,   444,   447,   450,   453,   456,   459,
   462,   465,   468,   472,   476,   480,   484,   488,   492,   493,
   494,   505,   506,   514,   518,   519,   525,   528,   532,   536,
   540,   544,   548,   551,   554,   557,   561,   565,   567,   571,
   575,   579,   583,   587,   590,   593,   596,   600,   604,   605,
   606,   614,   618,   622,   623,   631,   632,   640,   641,   651,
   652,   653,   656,   657,   662,   665,   667,   671,   674,   676
};

static const short yyrhs[] = {    -1,
    93,     0,    85,     0,     0,    85,    94,    95,     0,    95,
     0,    93,    85,    95,     0,    93,    85,     0,    59,   114,
     0,    60,   114,     0,    99,     0,   100,     0,    98,   101,
     0,    98,    74,   101,     0,    98,    74,     0,    98,    76,
     0,    98,    76,    96,     0,    98,    76,    50,     0,    98,
    76,    50,   128,     0,    98,    50,     0,    98,    50,   128,
     0,    98,    77,   102,     0,    98,    77,    50,     0,    98,
    78,   102,     0,    98,    78,    50,     0,   106,     0,   108,
     0,    80,     0,    81,     0,    82,     0,   109,     0,    83,
   117,     0,    84,     0,    49,     0,    96,    49,     0,    96,
     1,     0,    49,     0,    97,    49,     0,     0,    98,    72,
     0,    61,   113,     0,    62,   113,     0,    98,    73,     0,
    63,   102,     0,    64,   102,     0,    63,   112,     0,    64,
   112,     0,    69,   113,     0,    70,   113,     0,    71,   113,
     0,    65,     0,    65,   128,     0,    65,    49,     0,    65,
    49,   128,     0,    65,   128,    49,     0,    67,     0,    98,
    68,     0,    49,   130,     0,   130,     0,     0,   102,    49,
     0,     0,   103,    49,     0,   103,    50,     0,   103,   112,
     0,     0,   104,    34,     0,     0,    58,     0,    75,   104,
     0,    75,   104,   107,     0,   105,   112,     0,   107,    86,
   105,   114,     0,    79,   103,     0,    98,    49,     0,    98,
    66,    50,   103,   110,     0,    98,    66,    49,    50,   110,
     0,    98,    66,    97,   110,     0,    98,    66,   128,   110,
     0,    98,    66,   128,    49,   110,     0,    98,    66,    49,
   128,   110,     0,     0,   110,    86,   127,     0,   112,     0,
    52,     0,     1,     0,     0,   112,     0,     0,   112,     0,
    85,     0,    86,     0,    14,     0,    87,     0,     0,   111,
   114,   116,   118,   130,     0,     0,   111,   114,    47,   120,
    88,   119,   130,     0,   111,   114,     0,   120,   115,   111,
   114,     0,   120,   115,     0,     0,   130,     0,   130,     0,
     0,   122,    86,   123,   121,     0,     0,    47,   127,    88,
     0,     0,   128,     0,    52,     4,     0,    52,     4,   128,
     0,   125,     0,   126,    86,   125,     0,     0,   128,     0,
   130,     0,     1,     0,     4,     0,     9,     0,    11,     0,
     1,     0,   112,    14,     0,     0,   112,    47,   131,   144,
    88,     0,    53,     0,    54,     0,   148,     0,    52,     0,
    48,     0,    51,     0,    55,     0,    56,     0,     0,    89,
   132,   126,    90,     0,     0,    32,   111,   133,   130,     0,
     0,   112,    87,   134,   130,     0,   130,    32,   114,     0,
    44,   130,     0,   130,    22,   130,     0,   130,    19,   130,
     0,   130,    23,   130,     0,   130,    20,   130,     0,   130,
    18,   130,     0,   130,    21,   130,     0,   130,    26,   130,
     0,   130,    27,   130,     0,   130,    29,   130,     0,   130,
    28,   130,     0,   130,    30,   130,     0,    33,   130,     0,
    31,   111,     0,    22,   111,     0,    23,   111,     0,    15,
   130,     0,    26,   130,     0,    27,   130,     0,    28,   130,
     0,    29,   130,     0,    30,   130,     0,   130,    24,   130,
     0,   130,    25,   130,     0,   130,    17,   130,     0,   130,
    16,   130,     0,   130,    15,   130,     0,   130,     3,   147,
     0,     0,     0,   130,    45,    89,    46,   135,   127,    91,
   136,   127,    90,     0,     0,   130,    45,    89,   112,   137,
   127,    90,     0,   130,    45,   114,     0,     0,   130,    46,
   138,   128,    91,     0,    34,   130,     0,   130,    11,   130,
     0,   130,     9,   130,     0,   130,     7,   130,     0,   130,
    10,   130,     0,   130,     8,   130,     0,    12,   130,     0,
    13,   130,     0,    14,   130,     0,   130,     5,   130,     0,
   130,     6,   130,     0,    57,     0,   130,    40,   130,     0,
   130,    43,   130,     0,   130,    41,   130,     0,   130,    42,
   130,     0,   130,    39,   130,     0,    35,   130,     0,    36,
   130,     0,    37,   130,     0,    47,   122,    88,     0,   130,
    31,   130,     0,     0,     0,   111,   112,   139,   124,   140,
   129,   130,     0,    45,   112,   113,     0,     4,   112,   113,
     0,     0,    40,   114,    89,   122,    90,   141,   130,     0,
     0,    38,   114,    89,   122,    90,   142,   130,     0,     0,
    38,   114,    31,   114,    89,   122,    90,   143,   130,     0,
     0,     0,   145,   130,     0,     0,   144,    86,   146,   130,
     0,   144,    86,     0,   130,     0,   147,     4,   130,     0,
   149,   114,     0,    58,     0,   149,    58,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   703,   704,   708,   711,   715,   716,   719,   722,   726,   729,
   732,   734,   736,   738,   740,   743,   746,   749,   752,   755,
   758,   761,   764,   767,   770,   773,   775,   777,   780,   783,
   786,   788,   790,   795,   798,   808,   813,   816,   828,   830,
   835,   838,   841,   844,   847,   850,   858,   866,   872,   875,
   886,   889,   892,   895,   898,   901,   904,   909,   912,   917,
   919,   932,   934,   945,   948,   956,   958,   963,   964,   968,
   975,   980,   994,  1010,  1013,  1024,  1027,  1030,  1043,  1049,
  1052,  1057,  1059,  1070,  1092,  1095,  1100,  1102,  1107,  1109,
  1114,  1114,  1116,  1118,  1122,  1126,  1127,  1136,  1139,  1146,
  1154,  1161,  1165,  1170,  1173,  1177,  1186,  1188,  1193,  1195,
  1198,  1201,  1206,  1271,  1357,  1359,  1364,  1369,  1372,  1375,
  1378,  1383,  1386,  1405,  1417,  1433,  1439,  1445,  1448,  1451,
  1457,  1463,  1466,  1469,  1537,  1599,  1602,  1616,  1644,  1676,
  1710,  1713,  1716,  1719,  1722,  1725,  1728,  1731,  1755,  1774,
  1777,  1780,  1783,  1789,  1807,  1815,  1823,  1829,  1835,  1854,
  1857,  1860,  1863,  1866,  1869,  1872,  1875,  1878,  1907,  1921,
  1927,  1944,  1970,  1987,  2034,  2060,  2089,  2092,  2102,  2112,
  2122,  2128,  2131,  2139,  2147,  2155,  2166,  2177,  2180,  2183,
  2186,  2189,  2192,  2195,  2198,  2201,  2204,  2207,  2261,  2265,
  2266,  2268,  2271,  2274,  2287,  2322,  2335,  2357,  2376,  2410,
  2428,  2446,  2460,  2483,  2497,  2503,  2512,  2531,  2547,  2549
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","'?'","':'",
"UNTIL","RELEASE","IMPL","EQUIV","OR","XOR","AND","FINALLY","GLOBALLY","NEXT",
"'|'","'^'","'&'","NE","EQ","GE","LE","'<'","'>'","ROL","ROR","'+'","'-'","'*'",
"'/'","'%'","'#'","IS","'~'","'!'","CARDINALITY","MIN","MAX","MAP","EQUALS",
"SUBSET","MINUS","UNION","INTERSECT","ATOM","'.'","'['","'('","NUMBER","STATE",
"COMP","CHARACTER","NAME","TRUE_","FALSE_","UNDEFINED","FATAL","EMPTY","PLACE",
"MODEL","GRAPH","LSTS","UNFOLD","BREADTH","DEPTH","STRONG","PATH","TERMINAL",
"COMPONENTS","CD","TRANSLATOR","COMPILEDIR","VISUAL","DUMP","EVAL","HIDE","SHOW",
"SUCC","PRED","GO","STATS","TIME","HELP","FUNCTION","EXIT","';'","','","'='",
"')'","'{'","'}'","']'","script","statements","@1","statement","statelist","statelist_",
"_opt_visual","analyze","strong","eval","state_","state","_opt_exclam","_opt_place",
"hide","hide_list","go","path","path_expr","typereference","name_","_opt_name",
"name","delim","next_eq","function","@2","@3","param_list","marking","marking_list_",
"@4","_opt_expr","_opt__expr","struct_expr","expr_","expr","quantifier","formula",
"@5","@6","@7","@8","@9","@10","@11","@12","@13","@14","@15","@16","@17","arg_list",
"@18","@19","colon_formula","placename","_nopt_place", NULL
};
#endif

static const short yyr1[] = {     0,
    92,    92,    93,    94,    93,    93,    93,    93,    95,    95,
    95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
    95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
    95,    95,    95,    96,    96,    96,    97,    97,    98,    98,
    99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
   100,   100,   100,   100,   100,   100,   100,   101,   101,   102,
   102,   103,   103,   103,   103,   104,   104,   105,   105,   106,
   106,   107,   107,   108,   108,   109,   109,   109,   109,   109,
   109,   110,   110,   111,   112,   112,   113,   113,   114,   114,
   115,   115,   116,   116,   118,   117,   119,   117,   120,   120,
   120,   120,   121,   122,   123,   122,   124,   124,   125,   125,
   125,   125,   126,   126,   127,   127,   128,   129,   129,   129,
   129,   130,   130,   131,   130,   130,   130,   130,   130,   130,
   130,   130,   130,   132,   130,   133,   130,   134,   130,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   135,   136,
   130,   137,   130,   130,   138,   130,   130,   130,   130,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
   130,   130,   130,   130,   130,   130,   130,   130,   139,   140,
   130,   130,   130,   141,   130,   142,   130,   143,   130,   144,
   145,   144,   146,   144,   144,   147,   147,   148,   149,   149
};

static const short yyr2[] = {     0,
     0,     1,     1,     0,     3,     1,     3,     2,     2,     2,
     1,     1,     2,     3,     2,     2,     3,     3,     4,     2,
     3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
     1,     2,     1,     1,     2,     2,     1,     2,     0,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     1,     2,     2,     3,     3,     1,     2,     2,     1,     0,
     2,     0,     2,     2,     2,     0,     2,     0,     1,     2,
     3,     2,     4,     2,     2,     5,     5,     4,     4,     5,
     5,     0,     3,     1,     1,     1,     0,     1,     0,     1,
     1,     1,     1,     1,     0,     5,     0,     7,     2,     4,
     2,     0,     1,     1,     0,     4,     0,     3,     0,     1,
     2,     3,     1,     3,     0,     1,     1,     1,     1,     1,
     1,     1,     2,     0,     5,     1,     1,     1,     1,     1,
     1,     1,     1,     0,     4,     0,     4,     0,     4,     3,
     2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     3,     3,     3,     3,     3,     3,     0,     0,
    10,     0,     7,     3,     0,     5,     2,     3,     3,     3,
     3,     3,     2,     2,     2,     3,     3,     1,     3,     3,
     3,     3,     3,     2,     2,     2,     3,     3,     0,     0,
     7,     3,     3,     0,     7,     0,     7,     0,     9,     0,
     0,     2,     0,     4,     2,     1,     3,     2,     1,     2
};

static const short yydefact[] = {    39,
     0,     0,     0,     0,     0,     0,     0,    56,     0,     0,
     0,    66,    62,    28,    29,    30,     0,    33,     4,     2,
     6,     0,    11,    12,    26,    27,    31,    86,    85,    90,
     9,    10,    88,    41,    42,    44,    46,    45,    47,   122,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   130,     0,   131,   129,   126,   127,
   132,   133,   188,   219,   134,     0,    84,    52,   117,   128,
     0,    48,    49,    50,    68,     0,     0,    84,    32,    39,
    39,     0,     0,     0,    57,    40,    43,     0,    16,    60,
    60,    13,    59,    61,     0,   183,   184,   185,   157,   155,
   156,   158,   159,   160,   161,   162,   154,   136,   153,   177,
   194,   195,   196,     0,     0,   141,     0,     0,   104,    54,
     0,   199,   123,   124,   138,    55,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   175,   220,
   218,    67,    69,     0,    71,    63,    64,    65,     0,     5,
     7,    58,    21,     0,    62,    82,    82,     0,    14,    34,
     0,     0,    23,    22,    25,    24,   203,     0,     0,     0,
     0,   202,   105,   197,   129,   113,     0,   110,   107,   211,
     0,   216,   168,   186,   187,   180,   182,   179,   181,   178,
   167,   166,   165,   146,   143,   145,   147,   142,   144,   163,
   164,   148,   149,   151,   150,   152,   198,   140,   193,   189,
   191,   192,   190,     0,   174,     0,    72,    68,    93,     0,
    94,    95,    82,    82,     0,    38,    78,    82,    79,    19,
    36,    35,   137,     0,     0,     0,     0,     0,     0,   135,
     0,   200,     0,     0,   139,     0,   169,   172,     0,     0,
     0,     0,     0,    77,    81,    76,     0,    80,     0,   206,
   204,   106,   103,   112,   114,     0,   116,     0,   213,   125,
   212,   217,     0,     0,   176,    73,    99,    91,    92,    97,
     0,    96,    83,     0,     0,     0,   108,   118,   119,   120,
   121,     0,     0,     0,     0,     0,     0,   208,   207,   205,
   201,   214,   170,   173,    98,   100,     0,     0,   209,     0,
   171,     0,     0,     0
};

static const short yydefgoto[] = {   342,
    20,    90,    21,   192,   186,    22,    23,    24,   102,    36,
    86,    85,   174,    25,   175,    26,    27,   257,    76,    77,
    34,    31,   311,   252,    89,   283,   326,   282,   292,   128,
   267,   272,   206,   207,   296,   297,   322,    79,   210,   131,
   198,   211,   303,   338,   304,   246,   209,   298,   316,   315,
   337,   273,   274,   323,   213,    80,    81
};

static const short yypact[] = {   483,
   192,   192,   199,   199,   106,   106,   887,-32768,   199,   199,
   199,-32768,-32768,-32768,-32768,-32768,    30,-32768,    48,   -64,
-32768,  1531,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -14,-32768,   -14,-32768,   244,
    30,  1737,  1737,  1737,  1737,    30,    30,  1737,  1737,  1737,
  1737,  1737,    30,    30,  1737,  1737,  1737,  1737,  1737,    19,
    21,  1737,    30,  1737,-32768,  1080,-32768,   245,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    30,    -8,     0,  1793,-32768,
   396,-32768,-32768,-32768,   253,   101,   247,-32768,-32768,  2047,
   575,  1144,  1208,  1609,-32768,-32768,-32768,   951,    15,    16,
    27,-32768,  1793,-32768,   580,  1973,  1973,  1973,   263,-32768,
-32768,   263,   263,   263,   263,   263,-32768,-32768,   263,   263,
   263,   263,   263,    -6,    -5,    -4,   580,     1,  1793,-32768,
  1272,-32768,-32768,-32768,-32768,-32768,  1737,  1737,  1737,  1737,
  1737,  1737,  1737,  1737,  1737,  1737,  1737,  1737,  1737,  1737,
  1737,  1737,  1737,  1737,  1737,  1737,  1737,  1737,  1737,  1737,
  1737,   672,  1737,  1737,  1737,  1737,  1737,   488,-32768,-32768,
-32768,-32768,-32768,    30,     2,-32768,-32768,-32768,   220,-32768,
-32768,  1793,-32768,   822,-32768,    76,    95,  1737,-32768,-32768,
  1337,    91,-32768,   -14,-32768,   -14,-32768,  1737,    21,  1737,
  1737,-32768,-32768,-32768,   155,-32768,   -52,-32768,    29,     7,
  1737,  1793,   144,  1833,  1833,  1871,  1871,  1908,  1941,  1973,
   709,  2003,  2032,  2059,  2059,   338,   338,   338,   338,   429,
   429,  2104,  2104,   311,   311,   311,   311,-32768,   279,   -13,
   117,   117,    -4,    22,-32768,  1737,-32768,    99,-32768,    53,
-32768,-32768,-32768,-32768,    97,-32768,    89,-32768,    89,-32768,
-32768,-32768,    -4,    96,   -39,   -29,  1737,  1401,  1272,-32768,
  1673,-32768,    66,  1737,  1833,  1737,-32768,-32768,    98,    26,
    57,    93,  1737,    89,    89,    89,  1015,    89,  1737,-32768,
-32768,-32768,  1793,-32768,-32768,    92,-32768,   267,    86,-32768,
  1793,  1793,   752,  1466,-32768,-32768,-32768,-32768,-32768,-32768,
    80,  1793,-32768,   -23,  1737,  1737,-32768,-32768,-32768,-32768,
-32768,  1737,  1737,   103,    94,  1737,    57,-32768,   263,   263,
  1793,  1793,-32768,-32768,  1793,-32768,  1737,  1466,   263,   105,
-32768,   187,   188,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,   -35,-32768,-32768,-32768,-32768,-32768,   107,    18,
    11,-32768,   -47,-32768,-32768,-32768,-32768,    60,   -10,    -1,
     8,     9,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -186,
-32768,-32768,   -66,-32768,   -22,     6,-32768,    72,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		2150


static const short yytable[] = {    30,
    30,    33,    33,    37,    39,   133,    87,    33,    33,    33,
    32,    35,    78,   265,   266,    88,    82,    83,    84,    28,
    91,    28,    28,    38,   199,   -89,    28,   165,   166,   167,
    28,   168,   169,   269,   104,   110,   111,   270,   134,   105,
   168,   169,   117,   118,    88,    88,   203,    -3,   136,   -89,
   290,    88,    88,    28,   180,   181,   203,    28,    30,    30,
   291,   127,   203,   190,   191,   193,   328,   277,   124,   125,
    29,   130,    29,    29,   132,   271,   195,    29,   135,    30,
    28,    29,   200,   201,   178,    30,   203,   248,   204,   171,
   -17,   261,  -210,   103,  -210,   179,   -82,    28,   183,   187,
   -74,    28,   314,    33,    29,   -60,    28,   -89,    29,   -89,
   -89,   -89,   197,   106,   107,   108,   109,   194,   196,   112,
   113,   114,   115,   116,   256,    33,   119,   120,   121,   122,
   123,    29,    -3,   126,   202,   129,   208,  -102,  -102,   262,
  -102,   -89,   -89,   258,   -89,   176,   177,   276,    29,   176,
   177,   299,    29,   300,   -60,   -85,   173,    29,   268,   167,
    30,   168,   169,   182,  -101,  -101,    30,  -101,   -85,   103,
   238,  -215,   247,  -215,   287,   -17,   245,   308,   309,   317,
   310,   -82,   -82,   334,   289,   -74,   343,   344,   305,   254,
   -60,   -89,    28,   333,   341,   255,   260,    30,   -87,    28,
   280,   -85,   295,     0,   189,     0,   -85,   264,   212,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
   235,   236,   237,   249,   239,   240,   241,   242,   243,   281,
     0,   -85,   278,    29,   -86,   -85,   259,    28,    88,     0,
    29,   279,   -70,   178,     0,     0,     0,   -86,   -85,   182,
   -89,     0,     0,     0,   313,     0,   250,   318,     0,   263,
   319,   129,   129,   294,   208,   320,   -89,   321,    30,    30,
   324,   325,   275,   -87,     0,     0,   172,     0,   306,   307,
   -86,   -85,     0,   -89,     0,   -86,   -85,     0,    29,     0,
   327,   163,   164,   165,   166,   167,   251,   168,   169,    88,
   173,     0,   284,   285,   286,   340,     0,   288,   164,   165,
   166,   167,     0,   168,   169,    30,     0,     0,     0,     0,
   -86,   -85,     0,   -89,     0,   336,     0,   -70,   293,     0,
     0,   161,   162,     0,     0,   301,     0,   302,     0,   163,
   164,   165,   166,   167,   312,   168,   169,     0,     0,     0,
   129,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     0,     0,     0,     0,     0,     0,   163,   164,   165,   166,
   167,     0,   168,   169,     0,     0,   329,   330,     0,     0,
     0,     0,     0,   331,   332,   -89,    28,   335,   -89,   -89,
   -89,   -89,   -89,   -89,   -89,   -89,   -89,     0,   339,     0,
   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,
   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,     0,     0,
     0,     0,     0,     0,   -89,   -89,   -89,   -89,   -89,     0,
   -89,   -89,     0,     0,   -89,     0,     0,    29,     0,     0,
     0,     0,     0,   170,   156,   157,   158,   159,   160,   161,
   162,     0,     0,     0,     0,     0,     0,   163,   164,   165,
   166,   167,     0,   168,   169,     0,     0,     0,     0,     0,
   -89,   -89,    -1,   -89,     0,   -89,   -89,   -89,    28,     0,
   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,     0,
     0,     0,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,
   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,
     0,     0,     0,     0,     0,     0,   -89,   -89,   -89,   -89,
   -89,     0,   -89,   -89,     0,     0,   -89,     0,     0,    29,
     0,     1,     2,     3,     4,     5,     6,     7,     0,     8,
     0,     9,    10,    11,     0,     0,     0,    12,     0,     0,
     0,    13,    14,    15,    16,    17,    18,    19,     0,     0,
     0,     0,   -89,   -89,    -8,   -89,   244,   -89,   -89,   -87,
    28,     0,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
   -87,     0,     0,     0,   -87,   -87,   -87,   -87,   -87,   -87,
   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
   -87,   -87,     0,     0,     0,     0,     0,     0,   -87,   -87,
   -87,   -87,   -87,     0,   -87,   -87,     0,     0,   -87,     0,
     0,    29,     0,     1,     2,     3,     4,     5,     6,     7,
     0,     8,     0,     9,    10,    11,     0,     0,     0,    12,
     0,     0,     0,    13,    14,    15,    16,    17,    18,    -8,
     0,     0,     0,     0,   -87,   -87,     0,   -87,     0,   -87,
   -87,   -89,    28,     0,   -89,   -89,   -89,   -89,   -89,   -89,
   -89,   -89,   -89,     0,     0,     0,   -89,   -89,   -89,   -89,
   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,   -89,
   -89,   -89,   -89,   -89,     0,     0,     0,     0,     0,     0,
   -89,   -89,   -89,   -89,   -89,     0,   -89,   -89,     0,     0,
   -89,     0,     0,    29,   146,   147,   148,   149,   150,   151,
   152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
   162,     0,     0,     0,     0,     0,     0,   163,   164,   165,
   166,   167,    40,   168,   169,    41,   -89,   -89,     0,   -89,
     0,   -89,   -89,    42,    43,    44,    45,     0,     0,     0,
     0,     0,     0,    46,    47,     0,     0,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     0,    61,     0,     0,     0,    62,    63,     0,    64,    65,
     0,     0,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   -37,    40,     0,     0,    41,     0,     0,     0,     0,
     0,     0,     0,    42,    43,    44,    45,     0,     0,     0,
    75,     0,  -115,    46,    47,     0,     0,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     0,    61,     0,     0,     0,    62,    63,     0,    64,    65,
   -37,   253,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,     0,     0,     0,     0,   -51,    40,     0,     0,
    41,     0,     0,     0,     0,     0,     0,     0,    42,    43,
    44,    45,     0,     0,     0,     0,   -37,   -37,    46,    47,
    75,     0,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,     0,    61,     0,     0,     0,
    62,    63,     0,    64,    65,    66,     0,    67,    68,    69,
    70,    71,    72,    73,    74,     0,     0,     0,     0,     0,
   -15,    40,     0,     0,    41,     0,     0,     0,     0,     0,
     0,     0,    42,    43,    44,    45,     0,     0,     0,     0,
     0,   -51,    46,    47,     0,    75,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,     0,
    61,     0,     0,     0,    62,    63,     0,    64,    65,   188,
     0,    67,    68,    69,    70,    71,    72,    73,    74,     0,
     0,     0,     0,     0,  -115,    40,     0,     0,    41,     0,
     0,     0,     0,     0,     0,     0,    42,    43,    44,    45,
     0,     0,     0,     0,     0,   -15,    46,    47,     0,    75,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
    58,    59,    60,     0,    61,     0,     0,     0,    62,    63,
     0,    64,    65,     0,     0,    67,    68,    69,    70,    71,
    72,    73,    74,     0,     0,     0,     0,     0,     0,   -53,
    40,     0,     0,    41,     0,     0,     0,     0,     0,     0,
     0,    42,    43,    44,    45,     0,     0,     0,     0,  -115,
  -115,    46,    47,    75,     0,    48,    49,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,     0,    61,
     0,     0,     0,    62,    63,     0,    64,    65,     0,     0,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
     0,     0,     0,   -75,    40,     0,     0,    41,     0,     0,
     0,     0,     0,     0,     0,    42,    43,    44,    45,     0,
     0,     0,     0,     0,   -53,    46,    47,     0,    75,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,     0,    61,     0,     0,     0,    62,    63,     0,
    64,    65,     0,     0,    67,    68,    69,    70,    71,    72,
    73,    74,     0,     0,     0,     0,     0,   -20,    40,     0,
     0,    41,     0,     0,     0,     0,     0,     0,     0,    42,
    43,    44,    45,     0,     0,     0,     0,     0,   -75,    46,
    47,     0,    75,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,     0,    61,     0,     0,
     0,    62,    63,     0,    64,    65,     0,     0,    67,    68,
    69,    70,    71,    72,    73,    74,     0,     0,     0,     0,
     0,     0,    40,     0,     0,    41,     0,     0,     0,     0,
     0,     0,     0,    42,    43,    44,    45,     0,     0,     0,
     0,     0,   -20,    46,    47,     0,    75,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     0,    61,     0,     0,     0,    62,    63,     0,    64,    65,
     0,     0,    67,   205,    69,    70,    71,    72,    73,    74,
     0,     0,     0,     0,     0,     0,   -18,    40,     0,     0,
    41,     0,     0,     0,     0,     0,     0,     0,    42,    43,
    44,    45,     0,     0,     0,     0,     0,  -109,    46,    47,
    75,  -109,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,     0,    61,     0,     0,     0,
    62,    63,     0,    64,    65,     0,     0,    67,    68,    69,
    70,    71,    72,    73,    74,     0,     0,     0,     0,     0,
     0,    40,     0,     0,    41,     0,     0,     0,     0,     0,
     0,     0,    42,    43,    44,    45,     0,     0,     0,     0,
     0,   -18,    46,    47,     0,    75,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,     0,
    61,     0,     0,     0,    62,    63,     0,    64,    65,     0,
     0,    67,    68,    69,    70,    71,    72,    73,    74,     0,
     0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
     0,     0,     0,     0,     0,     0,     0,    42,    43,    44,
    45,     0,     0,     0,     0,     0,  -111,    46,    47,    75,
  -111,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,     0,    61,     0,     0,     0,    62,
    63,     0,    64,    65,     0,     0,    67,    68,    69,    70,
    71,    72,    73,    74,     0,     0,     0,     0,     0,     0,
     0,    40,     0,     0,    41,     0,     0,     0,     0,     0,
     0,     0,    42,    43,    44,    45,     0,     0,     0,     0,
     0,     0,    46,    47,    75,  -115,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,     0,
    61,     0,     0,     0,    62,    63,     0,    64,    65,    92,
    93,    67,    68,    69,    70,    71,    72,    73,    74,     0,
     0,     0,     0,     0,     0,     0,    94,     0,    95,     0,
     0,     0,    96,    97,    98,     0,    99,   100,   101,    40,
     0,     0,    41,     0,     0,     0,     0,     0,     0,    75,
    42,    43,    44,    45,     0,     0,     0,     0,     0,     0,
    46,    47,     0,     0,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,     0,    61,     0,
     0,     0,    62,    63,     0,    64,    65,   184,   185,    67,
    68,    69,    70,    71,    72,    73,    74,     0,     0,     0,
     0,     0,     0,    40,     0,     0,    41,     0,     0,     0,
     0,     0,     0,     0,    42,    43,    44,    45,     0,     0,
     0,     0,     0,     0,    46,    47,     0,    75,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,     0,    61,     0,     0,     0,    62,    63,     0,    64,
    65,     0,     0,    67,    68,    69,    70,    71,    72,    73,
    74,     0,     0,     0,     0,     0,     0,    40,     0,     0,
    41,     0,     0,     0,     0,     0,     0,     0,    42,    43,
    44,    45,     0,     0,     0,     0,     0,     0,    46,    47,
  -115,    75,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,     0,    61,     0,     0,     0,
    62,    63,     0,    64,    65,     0,     0,    67,    68,    69,
    70,    71,    72,    73,    74,   137,     0,   138,   139,   140,
   141,   142,   143,   144,     0,     0,     0,   145,   146,   147,
   148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
   158,   159,   160,   161,   162,    75,     0,     0,     0,     0,
     0,   163,   164,   165,   166,   167,     0,   168,   169,   140,
   141,   142,   143,   144,     0,     0,     0,   145,   146,   147,
   148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
   158,   159,   160,   161,   162,     0,     0,     0,     0,     0,
     0,   163,   164,   165,   166,   167,     0,   168,   169,   142,
   143,   144,     0,     0,     0,   145,   146,   147,   148,   149,
   150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
   160,   161,   162,     0,     0,     0,     0,     0,     0,   163,
   164,   165,   166,   167,     0,   168,   169,   143,   144,     0,
     0,     0,   145,   146,   147,   148,   149,   150,   151,   152,
   153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     0,     0,     0,     0,     0,     0,   163,   164,   165,   166,
   167,   144,   168,   169,     0,   145,   146,   147,   148,   149,
   150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
   160,   161,   162,     0,     0,     0,     0,     0,     0,   163,
   164,   165,   166,   167,     0,   168,   169,   145,   146,   147,
   148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
   158,   159,   160,   161,   162,     0,     0,     0,     0,     0,
     0,   163,   164,   165,   166,   167,     0,   168,   169,   147,
   148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
   158,   159,   160,   161,   162,     0,     0,     0,     0,     0,
     0,   163,   164,   165,   166,   167,     0,   168,   169,   148,
   149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
   159,   160,   161,   162,     0,     0,     0,     0,     0,     0,
   163,   164,   165,   166,   167,     0,   168,   169,   150,   151,
   152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
   162,     0,     0,     0,     0,     0,     0,   163,   164,   165,
   166,   167,     0,   168,   169,     1,     2,     3,     4,     5,
     6,     7,     0,     8,     0,     9,    10,    11,     0,     0,
     0,    12,     0,     0,     0,    13,    14,    15,    16,    17,
    18,   158,   159,   160,   161,   162,     0,     0,     0,     0,
     0,     0,   163,   164,   165,   166,   167,     0,   168,   169
};

static const short yycheck[] = {     1,
     2,     3,     4,     5,     6,    14,    17,     9,    10,    11,
     2,     4,     7,   200,   201,    17,     9,    10,    11,     1,
    85,     1,     1,     6,    31,     0,     1,    41,    42,    43,
     1,    45,    46,    86,    49,    46,    47,    90,    47,    41,
    45,    46,    53,    54,    46,    47,    86,     0,    49,    31,
    90,    53,    54,     1,    90,    91,    86,     1,    60,    61,
    90,    63,    86,    49,    50,    50,    90,    46,    60,    61,
    52,    66,    52,    52,    76,    47,    50,    52,    87,    81,
     1,    52,    89,    89,    86,    87,    86,    86,    88,    81,
     0,     1,    86,    22,    88,    87,     0,     1,    93,    94,
     0,     1,   289,   105,    52,     0,     1,    89,    52,    89,
    85,    86,   105,    42,    43,    44,    45,   100,   101,    48,
    49,    50,    51,    52,    49,   127,    55,    56,    57,    58,
    59,    52,    85,    62,   127,    64,   131,    85,    86,    49,
    88,    85,    86,    49,    88,    49,    50,     4,    52,    49,
    50,    86,    52,    88,    49,     1,    58,    52,     4,    43,
   162,    45,    46,    92,    85,    86,   168,    88,    14,    98,
   162,    86,   174,    88,    86,    85,   168,    85,    86,    88,
    88,    85,    86,    90,    89,    85,     0,     0,    91,   184,
    85,     0,     1,    91,    90,   185,   191,   199,     0,     1,
   248,    47,   269,    -1,    98,    -1,    52,   199,   137,   138,
   139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
   149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
   159,   160,   161,    14,   163,   164,   165,   166,   167,   250,
    -1,    87,   244,    52,     1,     1,   187,     1,   250,    -1,
    52,   246,     0,   255,    -1,    -1,    -1,    14,    14,   188,
    14,    -1,    -1,    -1,   287,    -1,    47,     1,    -1,   198,
     4,   200,   201,   268,   269,     9,    85,    11,   280,   281,
   303,   304,   211,    85,    -1,    -1,    34,    -1,   280,   281,
    47,    47,    -1,    47,    -1,    52,    52,    -1,    52,    -1,
   311,    39,    40,    41,    42,    43,    87,    45,    46,   311,
    58,    -1,   253,   254,   255,   338,    -1,   258,    40,    41,
    42,    43,    -1,    45,    46,   327,    -1,    -1,    -1,    -1,
    87,    87,    -1,    87,    -1,   327,    -1,    85,   267,    -1,
    -1,    31,    32,    -1,    -1,   274,    -1,   276,    -1,    39,
    40,    41,    42,    43,   283,    45,    46,    -1,    -1,    -1,
   289,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
    43,    -1,    45,    46,    -1,    -1,   315,   316,    -1,    -1,
    -1,    -1,    -1,   322,   323,     0,     1,   326,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    -1,   337,    -1,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    -1,
    45,    46,    -1,    -1,    49,    -1,    -1,    52,    -1,    -1,
    -1,    -1,    -1,    58,    26,    27,    28,    29,    30,    31,
    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
    42,    43,    -1,    45,    46,    -1,    -1,    -1,    -1,    -1,
    85,    86,     0,    88,    -1,    90,    91,     0,     1,    -1,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
    -1,    -1,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
    43,    -1,    45,    46,    -1,    -1,    49,    -1,    -1,    52,
    -1,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
    -1,    69,    70,    71,    -1,    -1,    -1,    75,    -1,    -1,
    -1,    79,    80,    81,    82,    83,    84,    85,    -1,    -1,
    -1,    -1,    85,    86,     0,    88,    89,    90,    91,     0,
     1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
    41,    42,    43,    -1,    45,    46,    -1,    -1,    49,    -1,
    -1,    52,    -1,    59,    60,    61,    62,    63,    64,    65,
    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,
    -1,    -1,    -1,    79,    80,    81,    82,    83,    84,    85,
    -1,    -1,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
    91,     0,     1,    -1,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    -1,    -1,    -1,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
    39,    40,    41,    42,    43,    -1,    45,    46,    -1,    -1,
    49,    -1,    -1,    52,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
    42,    43,     1,    45,    46,     4,    85,    86,    -1,    88,
    -1,    90,    91,    12,    13,    14,    15,    -1,    -1,    -1,
    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
    -1,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,     0,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
    89,    -1,    91,    22,    23,    -1,    -1,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,
     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,
    14,    15,    -1,    -1,    -1,    -1,    85,    86,    22,    23,
    89,    -1,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
    44,    45,    -1,    47,    48,    49,    -1,    51,    52,    53,
    54,    55,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
     0,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
    -1,    85,    22,    23,    -1,    89,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,
    -1,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,     4,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,
    -1,    -1,    -1,    -1,    -1,    85,    22,    23,    -1,    89,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,
    -1,    47,    48,    -1,    -1,    51,    52,    53,    54,    55,
    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,     0,
     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    85,
    86,    22,    23,    89,    -1,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
    -1,    -1,    -1,    44,    45,    -1,    47,    48,    -1,    -1,
    51,    52,    53,    54,    55,    56,    57,    58,    -1,    -1,
    -1,    -1,    -1,     0,     1,    -1,    -1,     4,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,
    -1,    -1,    -1,    -1,    85,    22,    23,    -1,    89,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
    47,    48,    -1,    -1,    51,    52,    53,    54,    55,    56,
    57,    58,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,
    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,
    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    85,    22,
    23,    -1,    89,    26,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,
    -1,    44,    45,    -1,    47,    48,    -1,    -1,    51,    52,
    53,    54,    55,    56,    57,    58,    -1,    -1,    -1,    -1,
    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
    -1,    -1,    85,    22,    23,    -1,    89,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
    -1,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,
     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,
    14,    15,    -1,    -1,    -1,    -1,    -1,    86,    22,    23,
    89,    90,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
    44,    45,    -1,    47,    48,    -1,    -1,    51,    52,    53,
    54,    55,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
    -1,    85,    22,    23,    -1,    89,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    -1,
    -1,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,     4,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,
    15,    -1,    -1,    -1,    -1,    -1,    86,    22,    23,    89,
    90,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,    44,
    45,    -1,    47,    48,    -1,    -1,    51,    52,    53,    54,
    55,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
    -1,    -1,    22,    23,    89,    90,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    68,    -1,
    -1,    -1,    72,    73,    74,    -1,    76,    77,    78,     1,
    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    89,
    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
    22,    23,    -1,    -1,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    -1,    40,    -1,
    -1,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    -1,    -1,    -1,
    -1,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    12,    13,    14,    15,    -1,    -1,
    -1,    -1,    -1,    -1,    22,    23,    -1,    89,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
    48,    -1,    -1,    51,    52,    53,    54,    55,    56,    57,
    58,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,
    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
    88,    89,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
    44,    45,    -1,    47,    48,    -1,    -1,    51,    52,    53,
    54,    55,    56,    57,    58,     3,    -1,     5,     6,     7,
     8,     9,    10,    11,    -1,    -1,    -1,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    89,    -1,    -1,    -1,    -1,
    -1,    39,    40,    41,    42,    43,    -1,    45,    46,     7,
     8,     9,    10,    11,    -1,    -1,    -1,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
    -1,    39,    40,    41,    42,    43,    -1,    45,    46,     9,
    10,    11,    -1,    -1,    -1,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
    40,    41,    42,    43,    -1,    45,    46,    10,    11,    -1,
    -1,    -1,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
    43,    11,    45,    46,    -1,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,
    40,    41,    42,    43,    -1,    45,    46,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
    -1,    39,    40,    41,    42,    43,    -1,    45,    46,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
    -1,    39,    40,    41,    42,    43,    -1,    45,    46,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
    39,    40,    41,    42,    43,    -1,    45,    46,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
    42,    43,    -1,    45,    46,    59,    60,    61,    62,    63,
    64,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
    -1,    75,    -1,    -1,    -1,    79,    80,    81,    82,    83,
    84,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
    -1,    -1,    39,    40,    41,    42,    43,    -1,    45,    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 710 "parser/marde.y"
{ command = true; dewarn ("extraneous semicolon"); ;
    break;}
case 4:
#line 713 "parser/marde.y"
{ command = true; dewarn ("extraneous semicolon"); ;
    break;}
case 5:
#line 715 "parser/marde.y"
{ command = true; ;
    break;}
case 6:
#line 718 "parser/marde.y"
{ command = true; ;
    break;}
case 7:
#line 721 "parser/marde.y"
{ command = true; ;
    break;}
case 9:
#line 728 "parser/marde.y"
{ if (yyvsp[0].s) currentState = model (yyvsp[0].s, 0, true) ? 0 : CARD_T_MAX; ;
    break;}
case 10:
#line 731 "parser/marde.y"
{ if (yyvsp[0].s) currentState = model (0, yyvsp[0].s, false) ? 0 : CARD_T_MAX; ;
    break;}
case 15:
#line 742 "parser/marde.y"
{ eval (currentState, resolveName (newString ("eval")), visual); ;
    break;}
case 16:
#line 745 "parser/marde.y"
{ show (currentState, visual); ;
    break;}
case 17:
#line 748 "parser/marde.y"
{ if (yyvsp[0].ia) { show (yyvsp[0].ia, visual); delete[] yyvsp[0].ia; } ;
    break;}
case 18:
#line 751 "parser/marde.y"
{ comp_show (yyvsp[0].i, 0, visual); ;
    break;}
case 19:
#line 754 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) comp_show (yyvsp[-1].i, yyvsp[0].expr, visual); ;
    break;}
case 20:
#line 757 "parser/marde.y"
{ comp_show (yyvsp[0].i, 0, visual); ;
    break;}
case 21:
#line 760 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) comp_show (yyvsp[-1].i, yyvsp[0].expr, visual); ;
    break;}
case 22:
#line 763 "parser/marde.y"
{ succ (yyvsp[0].i, visual); ;
    break;}
case 23:
#line 766 "parser/marde.y"
{ comp_succ (yyvsp[0].i, visual); ;
    break;}
case 24:
#line 769 "parser/marde.y"
{ pred (yyvsp[0].i, visual); ;
    break;}
case 25:
#line 772 "parser/marde.y"
{ comp_pred (yyvsp[0].i, visual); ;
    break;}
case 28:
#line 779 "parser/marde.y"
{ stats (); ;
    break;}
case 29:
#line 782 "parser/marde.y"
{ showtimes (); ;
    break;}
case 30:
#line 785 "parser/marde.y"
{ help (); ;
    break;}
case 33:
#line 792 "parser/marde.y"
{ exiting = true; YYABORT; ;
    break;}
case 34:
#line 797 "parser/marde.y"
{ yyval.ia = new card_t[2]; yyval.ia[0] = 1; yyval.ia[1] = yyvsp[0].i; ;
    break;}
case 35:
#line 800 "parser/marde.y"
{
	  if ((yyval.ia = yyvsp[-1].ia)) {
	    yyval.ia = new card_t[*yyval.ia + 2];
	    memcpy (yyval.ia, yyvsp[-1].ia, (1 + *yyvsp[-1].ia) * sizeof *yyvsp[-1].ia);
	    delete[] yyvsp[-1].ia;
	    yyval.ia[++(*yyval.ia)] = yyvsp[0].i;
	  }
	;
    break;}
case 36:
#line 810 "parser/marde.y"
{ delete[] yyvsp[-1].ia; yyval.ia = 0; ;
    break;}
case 37:
#line 815 "parser/marde.y"
{ yyval.ia = new card_t[2]; yyval.ia[0] = 1; yyval.ia[1] = yyvsp[0].i; ;
    break;}
case 38:
#line 818 "parser/marde.y"
{
	  if ((yyval.ia = yyvsp[-1].ia)) {
	    yyval.ia = new card_t[*yyval.ia + 2];
	    memcpy (yyval.ia, yyvsp[-1].ia, (1 + *yyvsp[-1].ia) * sizeof *yyvsp[-1].ia);
	    delete[] yyvsp[-1].ia;
	    yyval.ia[++(*yyval.ia)] = yyvsp[0].i;
	  }
	;
    break;}
case 39:
#line 829 "parser/marde.y"
{ visual = 0; ;
    break;}
case 40:
#line 832 "parser/marde.y"
{ visual++; ;
    break;}
case 41:
#line 837 "parser/marde.y"
{ lsts (yyvsp[0].s); ;
    break;}
case 42:
#line 840 "parser/marde.y"
{ unfold (yyvsp[0].s); ;
    break;}
case 43:
#line 843 "parser/marde.y"
{ dump (visual); ;
    break;}
case 44:
#line 846 "parser/marde.y"
{ analyze (yyvsp[0].i, true); ;
    break;}
case 45:
#line 849 "parser/marde.y"
{ analyze (yyvsp[0].i, false); ;
    break;}
case 46:
#line 852 "parser/marde.y"
{
	  if (yyvsp[0].s) {
	    currentState = CARD_T_MAX;
	    if (model (yyvsp[0].s, 0, false)) analyze (0, true);
	  }
	;
    break;}
case 47:
#line 860 "parser/marde.y"
{
	  if (yyvsp[0].s) {
	    currentState = CARD_T_MAX;
	    if (model (yyvsp[0].s, 0, false)) analyze (0, false);
	  }
	;
    break;}
case 48:
#line 868 "parser/marde.y"
{
	  if (!yyvsp[0].s && (yyvsp[0].s = getenv ("HOME"))) yyvsp[0].s = newString (yyvsp[0].s);
	  if (yyvsp[0].s && chdir (yyvsp[0].s)) perror (yyvsp[0].s); delete[] yyvsp[0].s;
	;
    break;}
case 49:
#line 874 "parser/marde.y"
{ delete[] translator; translator = yyvsp[0].s; ;
    break;}
case 50:
#line 877 "parser/marde.y"
{
#ifdef EXPR_COMPILE
	  delete[] compiledir; compiledir = yyvsp[0].s;
#else // EXPR_COMPILE
	  delete[] yyvsp[0].s; deerror ("no support for code generator");
#endif // EXPR_COMPILE
	;
    break;}
case 51:
#line 888 "parser/marde.y"
{ strong (currentState, 0); ;
    break;}
case 52:
#line 891 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) strong (currentState, yyvsp[0].expr); ;
    break;}
case 53:
#line 894 "parser/marde.y"
{ strong (yyvsp[0].i, 0); ;
    break;}
case 54:
#line 897 "parser/marde.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr))) strong (yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 55:
#line 900 "parser/marde.y"
{ if ((yyvsp[-1].expr = ensureBool (yyvsp[-1].expr))) strong (yyvsp[0].i, yyvsp[-1].expr); ;
    break;}
case 56:
#line 903 "parser/marde.y"
{ terminal (); ;
    break;}
case 57:
#line 906 "parser/marde.y"
{ allcomps (visual); ;
    break;}
case 58:
#line 911 "parser/marde.y"
{ eval (yyvsp[-1].i, yyvsp[0].expr, visual); ;
    break;}
case 59:
#line 914 "parser/marde.y"
{ eval (currentState, yyvsp[0].expr, visual); ;
    break;}
case 60:
#line 918 "parser/marde.y"
{ yyval.i = currentState; ;
    break;}
case 61:
#line 921 "parser/marde.y"
{
	  if ((yyval.i = yyvsp[-1].i) != currentState) {
	    thePrinter.printRaw ("ignoring extraneous state qualifier ");
	    thePrinter.printState (yyvsp[0].i);
	    thePrinter.finish ();
	  }
	  else
	    yyval.i = yyvsp[0].i;
	;
    break;}
case 62:
#line 933 "parser/marde.y"
{ yyval.i = currentState; ;
    break;}
case 63:
#line 936 "parser/marde.y"
{
	  if ((yyval.i = yyvsp[-1].i) != currentState) {
	    thePrinter.printRaw ("ignoring extraneous state qualifier ");
	    thePrinter.printState (yyvsp[0].i);
	    thePrinter.finish ();
	  }
	  else
	    yyval.i = yyvsp[0].i;
	;
    break;}
case 64:
#line 947 "parser/marde.y"
{ deerror ("expecting a state number"); yyval.i = yyvsp[-1].i; ;
    break;}
case 65:
#line 950 "parser/marde.y"
{
	  deerror ("expecting a state number");
	  delete[] yyvsp[0].s; yyval.i = yyvsp[-1].i;
	;
    break;}
case 66:
#line 957 "parser/marde.y"
{ hide = true; ;
    break;}
case 67:
#line 960 "parser/marde.y"
{ if (!hide) deerror ("ignoring extraneous `!'"); hide = false; ;
    break;}
case 70:
#line 970 "parser/marde.y"
{
	  if (isNet ())
	    for (unsigned place = net->getNumPlaces (); place--; )
	      net->getPlace (place).setSuppressed (hide);
	;
    break;}
case 71:
#line 977 "parser/marde.y"
{ isNet (); ;
    break;}
case 72:
#line 982 "parser/marde.y"
{
	  if (net && yyvsp[0].s) {
	    if (const class Place* p = net->getPlace (yyvsp[0].s))
	      p->setSuppressed (hide);
	    else {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	    }
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 73:
#line 996 "parser/marde.y"
{
	  if (net && yyvsp[0].s) {
	    if (const class Place* p = net->getPlace (yyvsp[0].s))
	      p->setSuppressed (hide);
	    else {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	    }
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 74:
#line 1012 "parser/marde.y"
{ if (isState (yyvsp[0].i)) currentState = yyvsp[0].i; ;
    break;}
case 75:
#line 1015 "parser/marde.y"
{
	  if (visual) {
	    thePrinter.printRaw ("ignoring extraneous `visual'");
	    thePrinter.finish ();
	  }
	  if (isState (yyvsp[0].i)) currentState = yyvsp[0].i;
	;
    break;}
case 76:
#line 1026 "parser/marde.y"
{ path_sc (yyvsp[-1].i, yyvsp[-2].i, yyvsp[0].expr, visual); ;
    break;}
case 77:
#line 1029 "parser/marde.y"
{ path_cs (yyvsp[-1].i, yyvsp[-2].i, yyvsp[0].expr, visual); ;
    break;}
case 78:
#line 1032 "parser/marde.y"
{
	  if (!yyvsp[-1].ia || !*yyvsp[-1].ia)
	    yyvsp[0].expr->destroy ();
	  else if (*yyvsp[-1].ia <= 2) {
	    card_t src = *yyvsp[-1].ia >= 2 ? yyvsp[-1].ia[2] : currentState, dest = yyvsp[-1].ia[1];
	    path_ss (src, dest, yyvsp[0].expr, visual);
	  }
	  else
	    path_sl (currentState, yyvsp[-1].ia, yyvsp[0].expr, visual);
	  delete[] yyvsp[-1].ia;
	;
    break;}
case 79:
#line 1045 "parser/marde.y"
{
	  if ((yyvsp[-1].expr = ensureBool (yyvsp[-1].expr)))
	    path_se (currentState, *yyvsp[-1].expr, yyvsp[0].expr, visual);
	;
    break;}
case 80:
#line 1051 "parser/marde.y"
{ if ((yyvsp[-2].expr = ensureBool (yyvsp[-2].expr))) path_se (yyvsp[-1].i, *yyvsp[-2].expr, yyvsp[0].expr, visual); ;
    break;}
case 81:
#line 1054 "parser/marde.y"
{ if ((yyvsp[-1].expr = ensureBool (yyvsp[-1].expr))) rpath_se (yyvsp[-2].i, *yyvsp[-1].expr, yyvsp[0].expr, visual); ;
    break;}
case 82:
#line 1058 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 83:
#line 1061 "parser/marde.y"
{
	  if ((yyval.expr = yyvsp[-2].expr)) {
	    deerror ("ignoring extraneous path condition");
	    yyvsp[0].expr->destroy ();
	  }
	  else
	    yyval.expr = ensureBool (yyvsp[0].expr);
	;
    break;}
case 84:
#line 1072 "parser/marde.y"
{
	  if (!yyvsp[0].s || !isNet ()) yyval.type = NULL;
	  else if ((yyval.type = net->getType (yyvsp[0].s)));
	  else if (!strcmp (yyvsp[0].s, "bool"))
	    yyval.type = &Net::getBoolType ();
	  else if (!strcmp (yyvsp[0].s, "int"))
	    yyval.type = &Net::getIntType ();
	  else if (!strcmp (yyvsp[0].s, "unsigned"))
	    yyval.type = &Net::getCardType ();
	  else if (!strcmp (yyvsp[0].s, "char"))
	    yyval.type = &Net::getCharType ();
	  else {
	    thePrinter.printRaw ("undefined type ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.finish ();
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 85:
#line 1094 "parser/marde.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 86:
#line 1097 "parser/marde.y"
{ yyval.s = NULL; ;
    break;}
case 87:
#line 1101 "parser/marde.y"
{ yyval.s = NULL; ;
    break;}
case 88:
#line 1104 "parser/marde.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 89:
#line 1108 "parser/marde.y"
{ deerror ("missing name"); yyval.s = NULL; ;
    break;}
case 90:
#line 1111 "parser/marde.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 95:
#line 1124 "parser/marde.y"
{ currentType = yyvsp[-2].type; ;
    break;}
case 96:
#line 1126 "parser/marde.y"
{ defun (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 97:
#line 1129 "parser/marde.y"
{
	  currentType = yyvsp[-4].type;
	  if (emptyParsed && currentArity)
	    deerror ("extraneous delimiter after formal parameter list");
	  emptyParsed = false;
	;
    break;}
case 98:
#line 1136 "parser/marde.y"
{ defun (yyvsp[-6].type, yyvsp[-5].s, yyvsp[0].expr); ;
    break;}
case 99:
#line 1141 "parser/marde.y"
{
	  assert (!currentArity && !currentParameters);
	  addParameter (yyvsp[-1].type, yyvsp[0].s);
	  emptyParsed = false;
	;
    break;}
case 100:
#line 1148 "parser/marde.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && emptyParsed)
	    deerror ("extraneous delimiter in parameter list");
	  addParameter (yyvsp[-1].type, yyvsp[0].s);
	  emptyParsed = false;
	;
    break;}
case 101:
#line 1156 "parser/marde.y"
{
	  if (emptyParsed)
	    deerror ("extraneous delimiter in parameter list");
	  emptyParsed = true;
	;
    break;}
case 102:
#line 1162 "parser/marde.y"
{ assert (!currentArity && !currentParameters); emptyParsed = true; ;
    break;}
case 103:
#line 1167 "parser/marde.y"
{ yyval.marking = ensureMarking (yyvsp[0].expr, currentType); ;
    break;}
case 104:
#line 1172 "parser/marde.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 105:
#line 1175 "parser/marde.y"
{ yyvsp[-1].expr = ensureMarking (yyvsp[-1].expr, currentType); ;
    break;}
case 106:
#line 1177 "parser/marde.y"
{
	  assert (!yyvsp[-3].expr || yyvsp[-3].expr->getKind () == Expression::eMarking);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].marking)
	    static_cast<class Marking*>(yyval.expr)->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.expr = yyvsp[0].marking;
	;
    break;}
case 107:
#line 1187 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 108:
#line 1190 "parser/marde.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 109:
#line 1194 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 110:
#line 1197 "parser/marde.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 111:
#line 1200 "parser/marde.y"
{ yyval.expr = namedComponent (yyvsp[-1].s, NULL); ;
    break;}
case 112:
#line 1203 "parser/marde.y"
{ yyval.expr = namedComponent (yyvsp[-2].s, yyvsp[0].expr); ;
    break;}
case 113:
#line 1208 "parser/marde.y"
{
	  if (currentContextType && !YYRECOVERING ()) {
	    assert (!currentComponent);

	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);
		class VectorExpression* v = new class VectorExpression (*type);

		if (!yyvsp[0].expr) {
		  deerror ("missing expression for first vector component");
		  v->destroy (), yyval.expr = NULL;
		}
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = v, v->setComponent (currentComponent, *yyvsp[0].expr);
		else
		  v->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tBuffer:
	      {
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);
		class BufferExpression* b = new class BufferExpression (*type);

		if (!yyvsp[0].expr)
		  yyval.expr = b;
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = b, b->append (*yyvsp[0].expr);
		else
		  b->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tStruct:
	      {
		if (!yyvsp[0].expr &&
		    !static_cast<const class StructType*>(currentContextType)
		    ->getSize ())
		  yyval.expr = CSE (new class Constant
			    (*new class StructValue (*currentContextType)));
		else {
		  class StructExpression* s =
		    new class StructExpression (*currentContextType);

		  if (isCompatible (yyvsp[0].expr, *s))
		    yyval.expr = s, s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		  else
		    s->destroy (), yyvsp[0].expr->destroy (),
		      yyval.expr = NULL, currentType = NULL;
		}
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 114:
#line 1273 "parser/marde.y"
{
	  if ((yyval.expr = yyvsp[-2].expr) && currentContextType && !YYRECOVERING ()) {
	    assert (currentComponent > 0);
	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		assert (yyval.expr->getKind () == Expression::eVector);
		class VectorExpression* v =
		  static_cast<class VectorExpression*>(yyval.expr);
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);

		if (currentComponent < type->getSize ()) {
		  if (!yyvsp[0].expr) {
		    thePrinter.printRaw ("missing array item ");
		    thePrinter.print (currentComponent);
		    thePrinter.finish ();
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    v->setComponent (currentComponent, *yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for array ");
		  printType (*type);
		  thePrinter.finish ();
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tBuffer:
	      {
		assert (yyval.expr->getKind () == Expression::eBuffer);
		class BufferExpression* b =
		  static_cast<class BufferExpression*>(yyval.expr);
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);

		if (b->hasCapacity ()) {
		  if (!yyvsp[0].expr || !b->getSize ()) {
		    thePrinter.printRaw ("missing buffer item ");
		    thePrinter.print (yyvsp[0].expr ? currentComponent : 0);
		    thePrinter.finish ();
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    b->append (*yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for buffer ");
		  printType (*type);
		  thePrinter.finish ();
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tStruct:
	      {
		assert (yyval.expr->getKind () == Expression::eStruct);
		class StructExpression* s =
		  static_cast<class StructExpression*>(yyval.expr);

		if (isCompatible (yyvsp[0].expr, *s))
		  s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		else
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (),
		    yyval.expr = NULL, currentType = NULL;
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 115:
#line 1358 "parser/marde.y"
{ yyval.expr = NULL; deerror ("missing expression"); ;
    break;}
case 116:
#line 1361 "parser/marde.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 117:
#line 1366 "parser/marde.y"
{ yyval.expr = ensureExpr (yyvsp[0].expr); ;
    break;}
case 118:
#line 1371 "parser/marde.y"
{ yyval.i = 0; ;
    break;}
case 119:
#line 1374 "parser/marde.y"
{ yyval.i = 1; ;
    break;}
case 120:
#line 1377 "parser/marde.y"
{ yyval.i = 2; ;
    break;}
case 121:
#line 1380 "parser/marde.y"
{ yyval.i = 3; ;
    break;}
case 122:
#line 1385 "parser/marde.y"
{ yyval.expr = NULL; ;
    break;}
case 123:
#line 1388 "parser/marde.y"
{
	  yyval.expr = NULL;
	  if (yyvsp[-1].s) {
	    if (class Function* f = getFunction (yyvsp[-1].s)) {
	      if (!(yyval.expr = fold (f->expand (NULL)))) {
		thePrinter.printRaw ("could not expand nullary function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.finish ();
	      }
	    }
	    else {
	      thePrinter.printRaw ("there is no nullary function ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	    }
	  }
	;
    break;}
case 124:
#line 1407 "parser/marde.y"
{
	  class Function* f = NULL;
	  if (yyvsp[-1].s && !(f = getFunction (yyvsp[-1].s))) {
	    thePrinter.printRaw ("there is no function ");
	    thePrinter.printQuoted (yyvsp[-1].s);
	    thePrinter.finish ();
	  }
	  delete[] yyvsp[-1].s;
	  functionStack.push (f);
	;
    break;}
case 125:
#line 1418 "parser/marde.y"
{
	  assert (!functionStack.empty ());
	  if (class Function* f = functionStack.top ()) {
	    yyval.expr = NULL;
	    if (yyvsp[-1].exprList && !(yyval.expr = fold (f->expand (yyvsp[-1].exprList)))) {
	      thePrinter.printRaw ("could not expand function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.finish ();
	    }
	  }
	  else
	    yyval.expr = NULL;
	  yyvsp[-1].exprList->destroy ();
	  functionStack.pop ();
	;
    break;}
case 126:
#line 1435 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
	;
    break;}
case 127:
#line 1441 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), false)));
	;
    break;}
case 128:
#line 1447 "parser/marde.y"
{ yyval.expr = yyvsp[0].place ? CSE (new class PlaceContents (*yyvsp[0].place)) : NULL; ;
    break;}
case 129:
#line 1450 "parser/marde.y"
{ yyval.expr = resolveName (yyvsp[0].s); ;
    break;}
case 130:
#line 1453 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getCardType (), yyvsp[0].i)));
	;
    break;}
case 131:
#line 1459 "parser/marde.y"
{
	  yyval.expr = CSE (new class Constant
		    (*new class LeafValue (Net::getCharType (), yyvsp[0].c)));
	;
    break;}
case 132:
#line 1465 "parser/marde.y"
{ yyval.expr = CSE (new class Undefined (Undefined::fError)); ;
    break;}
case 133:
#line 1468 "parser/marde.y"
{ yyval.expr = CSE (new class Undefined (Undefined::fFatalError)); ;
    break;}
case 134:
#line 1471 "parser/marde.y"
{
	  structLevels.push (StructLevel
			     (currentContextType, currentComponent));

	  if (!currentType) {
	    deerror ("cannot determine type of structured expression");
	    currentContextType = NULL, currentComponent = 0;
	  }
	  else {
	    assert (!structLevels.empty () || !currentComponent);
	    currentContextType = currentType;
	    currentComponent = 0;

	    switch (currentType->getKind ()) {
	    case Type::tStruct:
	      currentType =
		static_cast<const class StructType*>(currentContextType)
		->getSize ()
		? &(*static_cast<const class StructType*>(currentContextType))
		[currentComponent]
		: NULL;
	      break;
	    case Type::tVector:
	      currentType =
		&static_cast<const class VectorType*>(currentContextType)
		->getItemType ();

	      if (dewarnings) {
		const class Type& indexType =
		  static_cast<const class VectorType*>(currentContextType)
		  ->getIndexType ();

		switch (indexType.getKind ()) {
		case Type::tInt:
		case Type::tCard:
		case Type::tBool:
		case Type::tChar:
		case Type::tEnum:
		case Type::tId:
		  if (const class Constraint* constraint =
		      indexType.getConstraint ()) {
		    if (constraint->size () <= 1)
		      break;
		  }
		  else
		    break;
		default:
		  dewarn ("initializing an array indexed by something else"
			  " than a simple continuous type");
		}
	      }

	      break;
	    case Type::tBuffer:
	      currentType =
		&static_cast<const class BufferType*>(currentContextType)
		->getItemType ();

	      break;
	    default:
	      deerror ("cannot determine type of structured expression");
	      currentType = currentContextType = NULL;
	    }
	  }
	;
    break;}
case 135:
#line 1538 "parser/marde.y"
{
	  yyval.expr = yyvsp[-1].expr;
	  if (currentContextType) {
	    if (yyval.expr) {
	      switch (yyval.expr->getKind ()) {
	      case Expression::eStruct:
		{
		  class StructExpression* s =
		    static_cast<class StructExpression*>(yyval.expr);
		  if (s->getNextType ()) {
		    thePrinter.printRaw ("structure ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" not fully initialized");
		    thePrinter.finish ();
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      case Expression::eConstant:
	      case Expression::eBuffer:
		break;

	      case Expression::eVector:
		{
		  card_t diff =
		    static_cast<const class VectorType*>(currentContextType)
		    ->getSize () - currentComponent;

		  if (diff) {
		    thePrinter.print (diff);
		    thePrinter.printRaw (diff == 1
					 ? " element of array "
					 : " elements of array ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" left uninitialized");
		    thePrinter.finish ();

		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      default:
		assert (false);
	      }
	    }

	    StructLevel p = structLevels.top ();
	    currentType = currentContextType;
	    currentContextType = p.first;
	    currentComponent = p.second;
	  }
	  else
	    currentComponent = 0;

	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 136:
#line 1601 "parser/marde.y"
{ pushTypeContext (yyvsp[0].type); ;
    break;}
case 137:
#line 1603 "parser/marde.y"
{
	  if ((yyval.expr = yyvsp[0].expr) && yyval.expr->getKind () == Expression::eMarking &&
	      yyval.expr->getType () == currentType);
	  else if ((yyval.expr = noMarking (yyval.expr)) && currentType) {
	    if (!yyval.expr->getType ()) {
	      deerror ("expression to cast has no type");
	      yyval.expr->destroy (), yyval.expr = NULL;
	    }
	    else
	      makeCompatible (yyval.expr, *currentType, true);
	  }
	  popTypeContext ();
	;
    break;}
case 138:
#line 1618 "parser/marde.y"
{
	  StructLevel p (currentContextType, currentComponent);
	  structLevels.push (p);
	  currentContextType = currentType;
	  currentType = NULL, currentComponent = 0;

	  if (yyvsp[-1].s && currentContextType &&
	      currentContextType->getKind () == Type::tUnion) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if ((currentType = (*u)[yyvsp[-1].s]))
	      currentComponent = u->getIndex (yyvsp[-1].s);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (*u);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	    }
	  }
	  else if (yyvsp[-1].s)
	    deerror ("cannot assign the component of a non-union type");

	  delete[] yyvsp[-1].s;
	;
    break;}
case 139:
#line 1645 "parser/marde.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && currentType) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if (isCompatible (yyvsp[0].expr, currentType))
	      yyval.expr = fold (new class UnionExpression (*u, *yyvsp[0].expr,
						    currentComponent));
	    else {
	      thePrinter.printRaw ("type mismatch for ");
	      printType (*u);
	      thePrinter.printRaw (" component ");
	      thePrinter.printQuoted (u->getComponentName (currentComponent));
	      thePrinter.finish ();

	      yyvsp[0].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  assert (!structLevels.empty ());
	  StructLevel p = structLevels.top ();
	  currentType = currentContextType;
	  currentContextType = p.first;
	  currentComponent = p.second;
	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 140:
#line 1678 "parser/marde.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () && yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType* u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());

	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionTypeExpression (*yyvsp[-2].expr,
							  u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      deerror ("cannot determine the component of a non-union value");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 141:
#line 1712 "parser/marde.y"
{ if ((yyval.expr = noMarking (yyvsp[0].expr))) { yyval.expr->setAtomic (true); yyval.expr = CSE (yyval.expr); } ;
    break;}
case 142:
#line 1715 "parser/marde.y"
{ yyval.expr = newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 143:
#line 1718 "parser/marde.y"
{ yyval.expr = newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 144:
#line 1721 "parser/marde.y"
{ yyval.expr = newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr); ;
    break;}
case 145:
#line 1724 "parser/marde.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 146:
#line 1727 "parser/marde.y"
{ yyval.expr = newNotExpression (newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 147:
#line 1730 "parser/marde.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr)); ;
    break;}
case 148:
#line 1733 "parser/marde.y"
{
	  if (yyvsp[-2].expr && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    const class BufferType* type =
	      static_cast<const class BufferType*>(yyvsp[-2].expr->getType ());
	    if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && (yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) &&
		isCompatible (yyvsp[0].expr, &type->getItemType ())) {
	      if (yyvsp[-2].expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyvsp[-2].expr);
		yyval.expr = fold (new class BufferWrite (b->getBuffer (), *yyvsp[0].expr,
						  &b->getIndex ()));
		b->destroy ();
	      }
	      else
		yyval.expr = fold (new class BufferWrite (*yyvsp[-2].expr, *yyvsp[0].expr, NULL));
	    }
	    else
	      yyvsp[-2].expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bPlus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 149:
#line 1757 "parser/marde.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[-2].expr))) {
	      class Expression* index = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		index = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, ensureCard (yyvsp[0].expr), index));
	    }
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bMinus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 150:
#line 1776 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bDiv, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 151:
#line 1779 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMul, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 152:
#line 1782 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMod, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 153:
#line 1785 "parser/marde.y"
{
	  if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNot, *yyval.expr));
	;
    break;}
case 154:
#line 1791 "parser/marde.y"
{
	  if (yyvsp[0].type) {
	    card_t num = yyvsp[0].type->getNumValues ();
	    assert (num > 0);
	    if (num == CARD_T_MAX) {
	      deerror ("type has too many values to count");
	      yyval.expr = NULL;
	    }
	    else
	      yyval.expr = CSE (new class Constant
			(*new class LeafValue
			 (Net::getCardType (), num)));
	  }
	  else
	    yyval.expr = NULL;
	;
    break;}
case 155:
#line 1809 "parser/marde.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = CSE (new class Constant (yyvsp[0].type->getFirstValue ()));
	  else
	    yyval.expr = NULL;
	;
    break;}
case 156:
#line 1817 "parser/marde.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = CSE (new class Constant (yyvsp[0].type->getLastValue ()));
	  else
	    yyval.expr = NULL;
	;
    break;}
case 157:
#line 1825 "parser/marde.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uPred, *yyval.expr));
	;
    break;}
case 158:
#line 1831 "parser/marde.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uSucc, *yyval.expr));
	;
    break;}
case 159:
#line 1837 "parser/marde.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && yyvsp[0].expr->getType () &&
	      yyvsp[0].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[0].expr))) {
	      class Expression* index = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		index = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, 0, index));
	    }
	  }
	  else if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNeg, *yyval.expr));
	;
    break;}
case 160:
#line 1856 "parser/marde.y"
{ yyval.expr = newBufferUnop (BufferUnop::bPeek, yyvsp[0].expr); ;
    break;}
case 161:
#line 1859 "parser/marde.y"
{ yyval.expr = newBufferUnop (BufferUnop::bUsed, yyvsp[0].expr); ;
    break;}
case 162:
#line 1862 "parser/marde.y"
{ yyval.expr = newBufferUnop (BufferUnop::bFree, yyvsp[0].expr); ;
    break;}
case 163:
#line 1865 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRol, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 164:
#line 1868 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 165:
#line 1871 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bAnd, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 166:
#line 1874 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bXor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 167:
#line 1877 "parser/marde.y"
{ yyval.expr = newBinopExpression (BinopExpression::bOr, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 168:
#line 1880 "parser/marde.y"
{
	  yyvsp[-2].expr = noMarking (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].exprList) {
	    if (!yyvsp[-2].expr->getType ()) {
	      deerror ("left-hand-side of ? has no type");
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () != yyvsp[0].exprList->size ()) {
	      thePrinter.printRaw ("left-hand-side of ? has ");
	      thePrinter.print (yyvsp[-2].expr->getType ()->getNumValues ());
	      thePrinter.printRaw ("!=");
	      thePrinter.print (yyvsp[0].exprList->size ());
	      thePrinter.printRaw (" possible values");
	      thePrinter.finish ();
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () == 1) {
	      dewarn ("left-hand-side of ? has only one possible value");
	      yyval.expr = (*yyvsp[0].exprList)[0].copy (); yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy ();
	    }
	    else
	      yyval.expr = fold (new class IfThenElse (*yyvsp[-2].expr, *yyvsp[0].exprList));
	  }
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 169:
#line 1909 "parser/marde.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr))) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tVector) {
	      deerror ("left-hand-side of .{[index]expr} is not an array");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    else
	      pushTypeContext (&static_cast<const class VectorType*>
			       (yyvsp[-3].expr->getType ())->getIndexType ());
	  }
	;
    break;}
case 170:
#line 1922 "parser/marde.y"
{
	  if (yyvsp[-6].expr)
	    currentType = &static_cast<const class VectorType*>(yyvsp[-6].expr->getType ())
	      ->getItemType ();
	;
    break;}
case 171:
#line 1928 "parser/marde.y"
{
	  if (yyvsp[-9].expr) {
	    currentType = yyvsp[-9].expr->getType ();
	    const class VectorType& type =
	      *static_cast<const class VectorType*>(currentType);

	    if (makeCompatible (yyvsp[-4].expr, type.getIndexType ()) &&
		makeCompatible (yyvsp[-1].expr, type.getItemType ()))
	      yyval.expr = fold (new class VectorAssign (*yyvsp[-9].expr, *yyvsp[-4].expr, *yyvsp[-1].expr));
	    else
	      yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyvsp[-9].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	;
    break;}
case 172:
#line 1946 "parser/marde.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr)) && yyvsp[0].s) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tStruct) {
	      deerror ("left-hand-side of .{comp expr} is not a struct");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-3].expr->getType ());
	    if (const class Type* ct = type[yyvsp[0].s])
	      pushTypeContext (ct);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (type);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();

	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	  }
	  else
	    yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	;
    break;}
case 173:
#line 1971 "parser/marde.y"
{
	  if (yyvsp[-6].expr) {
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-6].expr->getType ());
	    currentType = type[yyvsp[-3].s];
	    if (makeCompatible (yyvsp[-1].expr, *currentType))
	      yyval.expr =
		fold (new class StructAssign (*yyvsp[-6].expr, type.getIndex (yyvsp[-3].s), *yyvsp[-1].expr));
	    else
	      yyvsp[-1].expr->destroy (), yyvsp[-6].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	  delete[] yyvsp[-3].s;
	;
    break;}
case 174:
#line 1989 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () &&
		yyvsp[-2].expr->getType ()->getKind () == Type::tStruct) {
	      const class StructType *s =
		static_cast<const class StructType*>(yyvsp[-2].expr->getType ());
	      if ((*s)[yyvsp[0].s])
		yyval.expr = fold (new class StructComponent (*yyvsp[-2].expr, s->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*s);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else if (yyvsp[-2].expr->getType () &&
		     yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType *u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());
	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionComponent (*yyvsp[-2].expr, u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      deerror ("only unions and structs have components");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;
	;
    break;}
case 175:
#line 2036 "parser/marde.y"
{
	  if ((yyvsp[-1].expr = ensureExpr (yyvsp[-1].expr)) && yyvsp[-1].expr->getType ()) {
	    switch (yyvsp[-1].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-1].expr->getType ());
		pushTypeContext (&type->getIndexType ());
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-1].expr->getKind () == Expression::eBufferIndex)
		deerror ("a buffer index has already been specified");
	      break;
	    default:
	      deerror ("only vector-typed expressions can be indexed");
	      yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	    }
	  }
	  else if (yyvsp[-1].expr) {
	    deerror ("no type for indexed expression");
	    yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	  }
	;
    break;}
case 176:
#line 2061 "parser/marde.y"
{
	  if (yyvsp[-4].expr) {
	    switch (yyvsp[-4].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-4].expr->getType ());
		popTypeContext ();

		if (isCompatible (yyvsp[-1].expr, &type->getIndexType ()))
		  yyval.expr = fold (new class VectorIndex (*yyvsp[-4].expr, *yyvsp[-1].expr));
		else
		  yyval.expr = NULL, yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy ();
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-4].expr->getKind () == Expression::eBufferIndex)
		yyvsp[-1].expr->destroy (), yyval.expr = yyvsp[-4].expr;
	      else
		yyval.expr = yyvsp[-1].expr ? CSE (new class BufferIndex (*yyvsp[-4].expr, *yyvsp[-1].expr)) : yyvsp[-4].expr;
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr = NULL, yyvsp[-1].expr->destroy ();
	;
    break;}
case 177:
#line 2091 "parser/marde.y"
{ yyval.expr = newNotExpression (yyvsp[0].expr); ;
    break;}
case 178:
#line 2094 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (true, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 179:
#line 2104 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 180:
#line 2114 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, newNotExpression (yyvsp[-2].expr), yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 181:
#line 2124 "parser/marde.y"
{
	  yyval.expr = newNotExpression
	    (newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)));
	;
    break;}
case 182:
#line 2130 "parser/marde.y"
{ yyval.expr = newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)); ;
    break;}
case 183:
#line 2133 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Finally, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 184:
#line 2141 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Globally, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 185:
#line 2149 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? CSE (new class TemporalUnop (TemporalUnop::Next, *yyvsp[0].expr))
	    : NULL;
	;
    break;}
case 186:
#line 2157 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = CSE (new class TemporalBinop (TemporalBinop::Until,
					       *yyvsp[-2].expr, *yyvsp[0].expr));
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 187:
#line 2168 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = CSE (new class TemporalBinop (TemporalBinop::Release,
					       *yyvsp[-2].expr, *yyvsp[0].expr));
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 188:
#line 2179 "parser/marde.y"
{ yyval.expr = CSE (new class EmptySet); ;
    break;}
case 189:
#line 2182 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sSubset, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 190:
#line 2185 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sIntersection, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 191:
#line 2188 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sMinus, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 192:
#line 2191 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sUnion, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 193:
#line 2194 "parser/marde.y"
{ yyval.expr = newSetExpression (SetExpression::sEquals, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 194:
#line 2197 "parser/marde.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cCard, yyvsp[0].expr); ;
    break;}
case 195:
#line 2200 "parser/marde.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMin, yyvsp[0].expr); ;
    break;}
case 196:
#line 2203 "parser/marde.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMax, yyvsp[0].expr); ;
    break;}
case 197:
#line 2206 "parser/marde.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 198:
#line 2209 "parser/marde.y"
{
	  yyvsp[-2].expr = ensureCard (yyvsp[-2].expr);
	  class Marking* m = ensureMarking (yyvsp[0].expr, currentType);

	  if ((yyval.expr = m) && yyvsp[-2].expr) {
	    if (yyvsp[-2].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[-2].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      card_t mult = card_t (static_cast<const class LeafValue&>(v));
	      if (!mult) {
		deerror ("zero multiplicity");
		yyvsp[-2].expr->destroy (), m->destroy ();
		yyval.expr = m = NULL;
	      }
	      else if (mult == 1)
		yyvsp[-2].expr->destroy ();
	      else {
		for (;;) {
		  if (class Expression* c = m->getMultiplicity ()) {
		    class Expression* card =
		      fold (new class BinopExpression (BinopExpression::bMul,
						       *yyvsp[-2].expr, *c));
		    m->setMultiplicity (card);
		  }
		  else
		    m->setMultiplicity (yyvsp[-2].expr);

		  if ((m = const_cast<class Marking*>(m->getNext ())))
		    yyvsp[-2].expr = CSE (new class Constant
			      (*new class LeafValue (*yyvsp[-2].expr->getType (), mult)));
		  else
		    break;
		}
	      }
	    }
	    else {
	      if (m->getNext ())
		yyval.expr = m = static_cast<class Marking*>
		  (CSE (new class Marking (m->getPlace (), m)));

	      class Expression* card = yyvsp[-2].expr;

	      if (class Expression* c = m->getMultiplicity ())
		card = fold
		  (new class BinopExpression (BinopExpression::bMul, *yyvsp[-2].expr, *c));
	      m->setMultiplicity (card);
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy ();
	;
    break;}
case 199:
#line 2263 "parser/marde.y"
{ beginQuantifier (yyvsp[0].s, yyvsp[-1].type); ;
    break;}
case 200:
#line 2265 "parser/marde.y"
{ continueQuantifier (ASSERT1 (yyvsp[-3].type)); ;
    break;}
case 201:
#line 2267 "parser/marde.y"
{ yyval.expr = endQuantifier (yyvsp[-5].s, yyvsp[-6].type, yyvsp[-3].expr, yyvsp[-1].i, yyvsp[0].expr); ;
    break;}
case 202:
#line 2270 "parser/marde.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, false); ;
    break;}
case 203:
#line 2273 "parser/marde.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, true); ;
    break;}
case 204:
#line 2276 "parser/marde.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    dewarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ())
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 205:
#line 2288 "parser/marde.y"
{
	  yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr));
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].expr && yyvsp[-5].s) {
	    yyvsp[0].expr = CSE (yyvsp[0].expr);
	    if (dewarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:subset is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      bool result = bool (static_cast<const class LeafValue&>(v));
	      yyvsp[0].expr->destroy ();
	      dewarn (result
		      ? "subset criterion always passes"
		      : "subset criterion always fails");
	      if (!result)
		yyval.expr->destroy (), yyval.expr = CSE (new class EmptySet);
	    }
	    else
	      yyval.expr = CSE (new class Submarking
			(*currentVariables.top (), *yyvsp[-3].expr, *yyvsp[0].expr));
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 206:
#line 2324 "parser/marde.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    dewarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ())
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 207:
#line 2336 "parser/marde.y"
{
	  yyvsp[0].expr = ensureExpr (yyvsp[0].expr);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[-5].s && yyvsp[0].expr) {
	    yyvsp[0].expr = CSE (yyvsp[0].expr);
	    if (dewarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:mapping is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    yyval.expr = CSE (new class Mapping
		      (*currentVariables.top (), NULL, *yyvsp[-3].expr, *yyvsp[0].expr));
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 208:
#line 2359 "parser/marde.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    dewarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-5].s && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-5].s, Net::getCardType (), false));
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else {
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	;
    break;}
case 209:
#line 2377 "parser/marde.y"
{
	  yyvsp[0].expr = ensureCard (yyvsp[0].expr);
	  yyval.expr = yyvsp[-3].expr;
	  if (yyvsp[-7].s && yyvsp[-5].s) {
	    class VariableDefinition* token = currentVariables.top ();
	    currentVariables.pop ();
	    class VariableDefinition* mult = currentVariables.top ();
	    currentVariables.pop ();
	    if (yyval.expr && yyvsp[0].expr) {
	      yyvsp[0].expr = CSE (yyvsp[0].expr);
	      if (dewarnings) {
		class VariableSet vars;
		vars.insert (*token);
		vars.insert (*mult);
		if (!yyvsp[0].expr->depends (vars, false)) {
		  thePrinter.printRaw ("Warning:mapping depends neither on ");
		  thePrinter.printQuoted (token->getName ());
		  thePrinter.printRaw (" nor ");
		  thePrinter.printQuoted (mult->getName ());
		  thePrinter.finish ();
		}
	      }
	      yyval.expr = CSE (new class Mapping
			(*token, mult, *yyvsp[-3].expr, *yyvsp[0].expr));
	    }
	    else
	      yyvsp[0].expr->destroy ();
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 210:
#line 2411 "parser/marde.y"
{
	  if (class Function* f = functionStack.top ()) {
	    if (!f->getArity ())
	      yyval.exprList = new class ExpressionList;
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" expects ");
	      thePrinter.print (f->getArity ());
	      thePrinter.printRaw (", not zero arguments");
	      thePrinter.finish ();
	      yyval.exprList = NULL;
	    }
	  }
	  else
	    yyval.exprList = NULL;
	;
    break;}
case 211:
#line 2429 "parser/marde.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (f->getArity ())
	      type = &(*f)[0].getType ();
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" takes no arguments");
	      thePrinter.finish ();
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 212:
#line 2446 "parser/marde.y"
{
	  if (currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      (yyval.exprList = new class ExpressionList)->append (*yyvsp[0].expr);
	    else {
	      yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 213:
#line 2462 "parser/marde.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (yyvsp[-1].exprList) {
	      if (f->getArity () > yyvsp[-1].exprList->size ())
		type = &(*f)[yyvsp[-1].exprList->size ()].getType ();
	      else {
		thePrinter.printRaw ("function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.printRaw (" takes only ");
		thePrinter.print (f->getArity ());
		thePrinter.printRaw (" arguments");
		thePrinter.finish ();
	      }
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 214:
#line 2483 "parser/marde.y"
{
	  if ((yyval.exprList = yyvsp[-3].exprList) && currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      yyval.exprList->append (*yyvsp[0].expr);
	    else {
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 215:
#line 2499 "parser/marde.y"
{ if ((yyval.exprList = yyvsp[-1].exprList)) deerror ("extraneous comma in argument list"); ;
    break;}
case 216:
#line 2505 "parser/marde.y"
{
	  if ((yyvsp[0].expr = noMarking (yyvsp[0].expr)))
	    (yyval.exprList = new class ExpressionList)->prepend (*yyvsp[0].expr);
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	;
    break;}
case 217:
#line 2514 "parser/marde.y"
{
	  yyvsp[0].expr = noMarking (yyvsp[0].expr);
	  if ((yyval.exprList = yyvsp[-2].exprList) && yyvsp[0].expr) {
	    if (yyval.exprList->getType () && yyvsp[0].expr->getType () &&
		yyval.exprList->getType () != yyvsp[0].expr->getType ()) {
	      deerror ("incompatible types in ?: expression");
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	    else
	      yyval.exprList->prepend (*yyvsp[0].expr);
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	;
    break;}
case 218:
#line 2533 "parser/marde.y"
{
	  if (yyvsp[0].s && isNet ()) {
	    if (!(yyval.place = net->getPlace (yyvsp[0].s))) {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	    }
	  }
	  else
	    yyval.place = NULL;
	  delete[] yyvsp[0].s;
	;
    break;}
case 220:
#line 2551 "parser/marde.y"
{ deerror ("ignoring extraneous `place'"); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 2554 "parser/marde.y"


#include "cmdline.h"

const char*
deline ()
{
  static char prompt1[22], prompt2[22];
  if (currentState == CARD_T_MAX) {
    memcpy (prompt1, "$", 2);
    memcpy (prompt2, ">", 2);
  }
  else {
    sprintf (prompt1, "@%u$", currentState);
    sprintf (prompt2, "@%u>", currentState);
  }
  extern volatile bool interrupted;
  if (interrupted)
    fputs ("[Interrupt]\n", stderr);
  interrupted = true;
  const char* line = cmdline (prompt1, prompt2);
  interrupted = false;
  return line;
}

#ifdef HAS_READLINE
/** Duplicate a string
 * @param s	string to be duplicated
 * @return	a copy of the string allocated with malloc ()
 */
inline static char*
dupstr (const char* s)
{
  size_t length = strlen (s) + 1;
  char* r = static_cast<char*>(malloc (length));
  if (r)
    memcpy (r, s, length);
  return r;
}

/** flag: is quoting desired? */
extern int rl_filename_completion_desired;
/** character to be appended to completed words (0 or ' ') */
extern int rl_completion_append_character;
/** Iterate through all file names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a file name, or NULL if no match
 */
extern "C" char* filename_completion_function (const char* text, int state);

/** Iterate through all keywords starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a command name, or NULL if no match
 */
extern "C" char*
marde_keywords (const char* text, int state)
{
  /** Keywords of the language */
  static const char* keywords[] = {
    "model \"", "graph \"", "breadth", "depth", "strong", "path",
    "terminal", "components", "cd", "translator \"", "compiledir \"",
    "visual", "dump", "eval", "hide", "show",
    "succ", "pred", "go", "stats", "time", "help",
    "function", "exit", "union", "is", "until",
    "release", "subset", "intersect", "equals", "minus", "atom",
    "empty", "place \"", "true", "false", "undefined", "fatal",
    "cardinality", "min", "max"
  };

  /** Number of the last keyword searched */
  static unsigned i;
  /** Length of the string */
  static size_t length;

  if (!state) {
    i = 0;
    length = strlen (text);
  }
  else {
    assert (i <= (sizeof keywords) / sizeof *keywords);
    assert (length == strlen (text));
  }

  while (i < (sizeof keywords) / sizeof *keywords) {
    const char* name = keywords[i++];
    if (!strncmp (name, text, length)) {
      if (name[strlen (name) - 1] == '"')
	rl_completion_append_character = 0;
      return dupstr (name);
    }
  }

  return NULL;
}

/** Iterate through place names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a place name, or NULL if no match
 */
extern "C" char*
marde_placenames (const char* text, int state)
{
  /** Number of the last place searched */
  static unsigned place;
  /** Length of the string */
  static size_t length;

  if (!state) {
    place = 0;
    length = strlen (text);
    rl_filename_completion_desired = 1;
  }
  else {
    assert (net && place <= net->getNumPlaces ());
    assert (length == strlen (text));
    assert (rl_filename_completion_desired);
  }

  if (!net)
    return NULL;

  while (place < net->getNumPlaces ()) {
    const char* name = net->getPlace (place++).getName ();
    if (!strncmp (name, text, length))
      return dupstr (name);
  }

  return NULL;
}

/** Iterate through type names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a type name, or NULL if no match
 */
extern "C" char*
marde_typenames (const char* text, int state)
{
  /** Last type searched */
  static Net::TypeMap::const_iterator type;
  /** Length of the string */
  static size_t length;

  if (!net)
    return NULL;

  if (!state) {
    type = net->beginTypename ();
    length = strlen (text);
    rl_filename_completion_desired = 1;
  }
  else {
    assert (length == strlen (text));
    assert (rl_filename_completion_desired);
  }

  while (type != net->endTypename ()) {
    const char* name = (type++)->first;
    if (!strncmp (name, text, length))
      return dupstr (name);
  }

  return NULL;
}

/** Iterate through other names starting with given text
 * @param text		text to be completed
 * @param state		flag: if state==0, start from the beginning
 * @return		a name
 */
extern "C" char*
marde_othernames (const char* text, int state)
{
  return NULL;
}

/** Completion function of readline
 * @param word		word to be completed
 * @param completer	the completion function
 */
extern "C" char **
completion_matches (const char* word,
		    char* (*completer) (const char*, int));

/** Complete place or type names
 * @param word		word to be completed
 * @param start		start offset of the string to be completed
 * @param end		end offset of the string to be completed
 */
extern "C" char**
marde_completer (const char* word, int start, int end)
{
  /** The line gathered so far */
  extern char* rl_line_buffer;
  assert (start >= 0 && start <= end);
  assert (size_t (end - start) == strlen (word));
  assert (size_t (end) <= strlen (rl_line_buffer));
  rl_completion_append_character = ' ';

  if ((start >= 6 && !memcmp (&rl_line_buffer[start - 6], "place ", 6)) ||
      (start >= 7 && !memcmp (&rl_line_buffer[start - 7], "place \"", 7)))
    return completion_matches (word, marde_placenames);
  if ((start >= 3 && !memcmp (&rl_line_buffer[start - 3], "is ", 3)) ||
      (start >= 4 && !memcmp (&rl_line_buffer[start - 4], "is \"", 4)))
    return completion_matches (word, marde_typenames);
  if ((start >= 3 && !memcmp (&rl_line_buffer[start - 3], "cd ", 3)) ||
      (start >= 4 && !memcmp (&rl_line_buffer[start - 4], "cd \"", 4)) ||
      (start >= 6 && (!memcmp (&rl_line_buffer[start - 6], "model ", 6) ||
		      !memcmp (&rl_line_buffer[start - 6], "graph ", 6))) ||
      (start >= 7 && (!memcmp (&rl_line_buffer[start - 7], "model \"", 7) ||
		      !memcmp (&rl_line_buffer[start - 7], "graph \"", 7) ||
		      !memcmp (&rl_line_buffer[start - 7], "depth \"", 7))) ||
      (start >= 9 && (!memcmp (&rl_line_buffer[start - 9],
			       "breadth \"", 9))) ||
      (start >= 11 && (!memcmp (&rl_line_buffer[start - 11],
				"translator ", 11) ||
		       !memcmp (&rl_line_buffer[start - 11],
				"compiledir ", 11))) ||
      (start >= 12 && (!memcmp (&rl_line_buffer[start - 12],
				"translator \"", 12) ||
		       !memcmp (&rl_line_buffer[start - 12],
				"compiledir \"", 12))))
    return completion_matches (word, filename_completion_function);
  return completion_matches (word, marde_keywords);
}
#endif // HAS_READLINE

void
dereset ()
{
  command = true;
  currentExpressions.clear ();
  delete[] currentParameters;
  currentParameters = 0;
  while (!functionStack.empty ()) functionStack.pop ();
  currentContextTransition = 0;
  currentType = currentContextType = 0;
  currentComponent = 0;
  while (!typeStack.empty ()) typeStack.pop ();
  emptyParsed = false;
  while (!structLevels.empty ()) structLevels.pop ();
  if (currentState == CARD_T_MAX) currentState = 0;
  delexreset ();
#ifdef HAS_READLINE
  init_cmdline ("marde", marde_completer, marde_othernames);
#endif // HAS_READLINE
}

static void
help (void)
{
  fputs ("Query language commands:\n"
	 "\tmodel \"MODELNAME\"\n"
	 "\tgraph \"GRAPHFILE\"\n"
	 "\t(breadth|depth) [STATE]\n"
	 "\t(breadth|depth) \"MODELNAME\"\n"
	 "\tlsts [\"OUTFILE\"]\n"
	 "\tunfold M?([lmpr](OUTFILE)?)?\n"
	 "\thide [!][[place] PLACENAME (, [place] PLACENAME)*]\n"
	 "\t[visual] [STATE] [eval] formula\n"
	 "\t[visual] show [STATE]\n"
	 "\t[visual] [show] COMP [expr]\n"
	 "\t[visual] (succ|pred) [STATE]\n"
	 "\t[visual] (succ|pred) COMP\n"
	 "\t[go] STATE\n"
	 "\tstrong [STATE] [expr]\n"
	 "\tterminal\n"
	 "\t[visual] components\n"
	 "\t[visual] path (STATE|COMP|expr) [STATE]\n"
	 "\t[visual] path STATE (COMP|expr)\n"
	 "\tstats\n"
	 "\ttime\n"
	 "\tcd \"DIRECTORY\"\n"
	 "\ttranslator [\"COMMAND\"]\n"
	 "\tcompiledir [\"DIRECTORY\"]\n"
	 "\thelp\n"
	 "\tfunction {function-definition}\n"
	 "\texit\n",
	 stderr);
}

static bool
isNet (void)
{
  if (net)
    return true;
  deerror ("no model has been loaded");
  return false;
}

static void
printType (const class Type& type)
{
  if (const char* name = type.getName ())
    thePrinter.print (name);
  else
    type.display (thePrinter);
}

static void pushTypeContext (const class Type* type)
{
  StructLevel p (currentContextType, currentComponent);
  structLevels.push (p);
  StructLevel q (currentType, 0);
  structLevels.push (q);

  currentType = type;
  currentContextType = NULL, currentComponent = 0;
}

static void popTypeContext ()
{
  StructLevel p = structLevels.top ();
  structLevels.pop ();
  currentType = p.first;
  assert (!p.second);
  p = structLevels.top ();
  structLevels.pop ();
  currentContextType = p.first;
  currentComponent = p.second;
}

static const class VariableDefinition*
getParameter (char* name)
{
  for (unsigned i = 0; i < currentArity; i++) {
    if (!strcmp (currentParameters[i]->getName (), name))
      return currentParameters[i];
  }

  return NULL;
}

static void
addParameter (const class Type* type, char* name)
{
  if (!type || !name) {
    delete[] name;
    return;
  }

  if (getParameter (name)) {
    thePrinter.printRaw ("ignoring redefinition of parameter ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    delete[] name;
    return;
  }

  if (dewarnings) {
    const char* shadow = 0;
    if (getConstant (name) || getConstantFunction (name))
      shadow = " shadows a constant";
    else if (net->getType (name))
      shadow = " shadows a type name";

    if (shadow) {
      thePrinter.printRaw ("Warning:parameter ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (shadow);
      thePrinter.finish ();
    }
  }

  class VariableDefinition** v =
    new class VariableDefinition*[currentArity + 1];
  assert (!currentArity || currentParameters);
  assert (currentArity || !currentParameters);

  memcpy (v, currentParameters, currentArity * sizeof *v);
  delete[] currentParameters;
  currentParameters = v;
  currentParameters[currentArity++] =
    new class VariableDefinition (name, *type, false);
}

static class Function*
getFunction (const char* name)
{
  if (!isNet ())
    return NULL;
  class Function* f = currentContextTransition
    ? currentContextTransition->getFunction (name)
    : NULL;
  return f ? f : net->getFunction (name);
}

static class Function*
getConstantFunction (const char* name)
{
  if (!isNet ())
    return NULL;
  class Function* f = currentContextTransition
    ? currentContextTransition->getFunction (name)
    : NULL;
  if (!f || f->getArity ())
    f = net->getFunction (name);
  return f && f->getArity () ? NULL : f;
}

static const class Constant*
getConstant (const char* name)
{
  if (!isNet ())
    return NULL;
  const class Constant* c = currentContextTransition
    ? currentContextTransition->getConstant (name)
    : NULL;
  return c ? c : net->getConstant (name);
}

static const class Expression*
getProposition (char* name)
{
  if (net)
    for (unsigned i = net->getNumProps (); i--; )
      if (!strcmp (net->getPropName (i), name))
	return &net->getProp (i);
  return 0;
}

static class Expression*
resolveName (char* name)
{
  const class Constant* c = getConstant (name);
  class Function* f = getConstantFunction (name);
  const card_t*const i =
    (currentType && currentType->getKind () == Type::tEnum)
    ? static_cast<const class EnumType*>(currentType)->getValue (name)
    : NULL;
  const class Expression* prop = getProposition (name);

  const class VariableDefinition* v = getParameter (name);
  if (v || (v = currentVariables.find (name)));
  else if (currentContextTransition &&
	   (v = currentContextTransition->getVariable (name)));
  else if (!c && !f && !i && !prop) {
    thePrinter.printRaw ("undefined variable ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
  }
  delete[] name;

  if (v)
    return static_cast<class Variable*>(CSE (new class Variable (*v)));
  if (c)
    return CSE (const_cast<class Constant*>(c)->copy ());
  else if (class Expression* expr = f ? f->expand (NULL) : NULL)
    return fold (expr);
  if (i)
    return enumValue (*static_cast<const class EnumType*>(currentType), *i);
  if (prop)
    return CSE (const_cast<class Expression*>(prop)->copy ());

  return NULL;
}

static class Expression*
ensureSet (class Expression* expr,
	   const class Type* type)
{
  return !expr || expr->isSet () ? expr : ensureMarking (expr, type);
}

static class Marking*
ensureMarking (class Expression* expr,
	       const class Type* type)
{
  if (!expr)
    return NULL;
  else if (expr->getKind () == Expression::eUndefined) {
    deerror ("undefined marking expressions are not allowed");
    expr->destroy ();
    return NULL;
  }

  assert (expr->getType () || expr->getKind () == Expression::eEmptySet);

  if (expr->getKind () == Expression::eMarking)
    return static_cast<class Marking*>(expr);
  else if (expr->isSet () || expr->isBasic ()) {
    if (!type || makeCompatible (expr, *type)) {
      class Marking* m = new class Marking (NULL);
      m->setToken (expr);
      return m;
    }
    else
      return NULL;
  }
  else {
    deerror ("marking expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
noMarking (class Expression* expr)
{
  if (expr && expr->getKind () == Expression::eMarking) {
    deerror ("marking expression not allowed here");
    expr->destroy ();
    return NULL;
  }

  return expr;
}

static class Expression*
ensureExpr (class Expression* expr)
{
  expr = noMarking (expr);

  if (expr && !expr->isBasic ()) {
    deerror ("basic expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureBool (class Expression* expr, bool undefined)
{
  expr = noMarking (expr);

  if (!expr)
    return NULL;

  if (expr->getKind () == Expression::eUndefined) {
    if (undefined)
      return expr;
    deerror ("undefined or fatal expression is not meaningful here");
    expr->destroy (); return NULL;
  }

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBool) {
    deerror ("boolean expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureInt (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tCard:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getIntType (), true));
    else if (expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    deerror ("signed integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tInt:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType ())
      return expr;
    /* fall through */
  default:
    deerror ("unsigned integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureIntCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType () ||
	     expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    deerror ("integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureBuffer (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBuffer) {
    deerror ("buffer expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureOrdered (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (!isOrdered (*expr->getType ())) {
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
enumValue (const class EnumType& type, card_t value)
{
  class LeafValue* e = new class LeafValue (type, value);
  if (type.isConstrained (*e))
    return CSE (new class Constant (*e));
  else {
    thePrinter.printRaw ("enumeration constant ");
    if (const char* c = type.getEnumName (value)) {
      thePrinter.print (c);
      thePrinter.delimiter ('=');
    }
    thePrinter.print (value);
    thePrinter.printRaw (" out of range for type ");
    printType (type);
    thePrinter.finish ();
    delete e;
    return NULL;
  }
}

static class Expression*
namedComponent (char* name, class Expression* expr)
{
  if (!name) {
    expr->destroy ();
    return NULL;
  }

  if (!currentContextType || currentContextType->getKind () != Type::tStruct) {
    thePrinter.printRaw ("named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" can only be used with a struct");
    thePrinter.finish ();
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  const class StructType& type =
    static_cast<const class StructType&>(*currentContextType);

  if (currentComponent < type.getSize ()) {
    const char* comp = type.getComponentName (currentComponent);
    if (strcmp (name, comp)) {
      thePrinter.printRaw ("expecting named component ");
      thePrinter.printQuoted (comp);
      thePrinter.printRaw (" instead of ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      expr->destroy ();
      delete[] name;
      return NULL;
    }
  }
  else {
    thePrinter.printRaw ("extraneous named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" at end of struct");
    thePrinter.finish ();
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  delete[] name;
  return expr;
}

static void
beginQuantifier (char* name, const class Type* type)
{
  if (name && type) {
    if (dewarnings) {
      const char* shadow = 0;
      if (currentVariables.find (name))
        shadow = " shadows another quantifier";
      else if ((currentContextTransition &&
		currentContextTransition->getVariable (name)))
	shadow = " shadows a transition variable";
      else if (getConstant (name))
	shadow = " shadows a constant";
      else if (currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)->
	       getValue (name))
	shadow = " shadows an enumeration constant";
      else if (net->getType (name))
	shadow = " shadows a type name";

      if (shadow) {
	thePrinter.printRaw ("quantifier ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (shadow);
	thePrinter.finish ();
      }
    }

    card_t size = type->getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      thePrinter.printRaw ("type ");
      printType (*type);
      thePrinter.printRaw (" has too many (");
      thePrinter.print (size);
      thePrinter.printRaw (") values for quantification");
      if (size && size < CARD_T_MAX)
	thePrinter.printRaw (" (try -q0)");
      thePrinter.finish ();
    }
    currentVariables.push (new class VariableDefinition (name, *type, true));
  }

  struct TypeContext tc = {
    currentContextType,
    currentType,
    currentComponent
  };
  typeStack.push (tc);

  currentContextType = NULL;
  currentComponent = 0;
  currentType = type;
}

static void
continueQuantifier (ASSERT1 (const class Type* type))
{
  assert (!currentContextType);
  assert (currentType == type);
  assert (!typeStack.empty ());
  struct TypeContext tc = typeStack.top ();
  typeStack.pop ();

  currentContextType = tc.context;
  currentType = tc.component;
  currentComponent = tc.numComponent;
}

static class Expression*
endQuantifier (char* name,
	       const class Type* type,
	       class Expression* condition,
	       unsigned kind,
	       class Expression* expr)
{
  if (name && type && expr && kind) {
    class VariableDefinition* var = currentVariables.top ();
    currentVariables.pop ();

    card_t size = var->getType ().getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      condition->destroy ();
      expr->destroy ();
      delete var;
      return NULL;
    }

    if ((condition = ensureBool (ensureExpr (condition))) && dewarnings) {
      class VariableSet vars;
      vars.insert (*var);
      if (!condition->depends (vars, false)) {
	thePrinter.printRaw ("Warning:condition is independent of ");
	thePrinter.printQuoted (var->getName ());
	thePrinter.finish ();
      }
    }

    class Valuation v;
    switch (kind) {
    case 1:
      if (class Marking* m = ensureMarking (expr, currentType)) {
	expr = m->quantify (v, currentContextTransition,
			    *var, condition, false);
	m->destroy ();
	delete var;
	if (!expr) {
	  if (check (v))
	    deerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return CSE (expr);
      }
      else
	expr = NULL;
      break;
    case 2:
    case 3:
      if ((expr = ensureBool (expr))) {
	class Expression* e =
	  BooleanBinop::quantify (kind != 2,
				  *expr, v, currentContextTransition,
				  *var, condition, false);
	expr->destroy ();
	delete var;
	if (!e) {
	  if (check (v))
	    deerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return CSE (e);
      }
      break;
    default:
      assert (false);
    }

    expr->destroy ();
    delete var;
    return NULL;
  }
  else {
    condition->destroy (), expr->destroy ();
    if (name && type) {
      class VariableDefinition* var = currentVariables.top ();
      currentVariables.pop ();
      delete var;
    }
    else
      delete[] name;
    return NULL;
  }
}

static class Expression*
quantifierVariable (char* prefix, char* quant, bool pred)
{
  char p = pred ? ',' : '.';
  if (!prefix) {
    delete[] prefix;
    delete[] quant;
    return NULL;
  }
  class VariableDefinition* var;
  if (currentVariables.empty ())
    var = NULL;
  else if (quant)
    var = currentVariables.find (quant);
  else
    var = currentVariables.top ();

  if (!var) {
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    if (quant) {
      thePrinter.printRaw (": quantifier ");
      thePrinter.print (quant);
      thePrinter.printRaw (" not found");
    }
    else
      thePrinter.printRaw (": no quantifier found");
    thePrinter.finish ();
  }
  else if (!var->isAggregate ()) {
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.printRaw (": variable ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (" is not a quantifier");
    thePrinter.finish ();
  }
  else if (!currentContextTransition) {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": cannot define ");
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.printRaw (" outside transition");
    thePrinter.finish ();
  }
  else if (!currentType) {
    if (const class VariableDefinition* qvar = var->findChild (prefix)) {
      delete[] quant;
      delete[] prefix;
      return CSE (new class Variable (*qvar, pred));
    }
    else {
      thePrinter.printRaw ("quantifier ");
      thePrinter.print (var->getName ());
      thePrinter.printRaw (": cannot determine the type of ");
      thePrinter.delimiter (p);
      thePrinter.print (prefix);
      thePrinter.finish ();
    }
  }
  else if (const class VariableDefinition* qvar =
	   var->addChild (prefix, *currentType)) {
    delete[] quant;
    return CSE (new class Variable (*qvar, pred));
  }
  else {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": contradictory type for ");
    thePrinter.delimiter (p);
    thePrinter.print (prefix);
    thePrinter.finish ();
  }

  delete[] prefix;
  delete[] quant;
  return NULL;
}

static bool
makeCompatible (class Expression*& expr,
		const class Type& type,
		bool casting)
{
  if (!expr) return false;
  if (expr->getType () == &type ||
      expr->getKind () == Expression::eEmptySet)
    return true;
  assert (!!expr->getType ());
  const class Type& srcType = *expr->getType ();
  if (((Typecast::isCastable (type) &&
	Typecast::isCastable (srcType)) ||
       Type::isCompatible (srcType, type)) &&
      expr->isBasic () && !expr->isSet ()) {
    bool isConstant = expr->getKind () == Expression::eConstant;
    expr = CSE (new class Typecast (type, *expr));
    if (!casting && dewarnings &&
	((!srcType.isAssignable (type) &&
	  srcType.getKind () != Type::tCard &&
	  srcType.getKind () != Type::tInt &&
	  type.getKind () != Type::tCard &&
	  type.getKind () != Type::tInt) ||
	 (!isConstant && !srcType.isAlwaysAssignable (type)))) {
      thePrinter.printRaw ("Warning:implicit conversion from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
    }
    if (isConstant && !(expr = fold (expr))) {
      thePrinter.printRaw ("cannot convert constant from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
      return false;
    }
    return true;
  }
  else {
    thePrinter.printRaw ("cannot convert from ");
    printType (srcType);
    thePrinter.printRaw (" to ");
    printType (type);
    thePrinter.finish ();
    return false;
  }
}

static bool
isCompatible (class Expression*& expr,
	      const class Type* type)
{
  if (!type) {
    deerror ("too many components for struct");
    return false;
  }

  if (!expr)
    return false;

  if (!expr->getType ()) {
    deerror ("expression has no type");
    return false;
  }

  return makeCompatible (expr, *type);
}

static bool
isCompatible (class Expression*& expr,
	      const class StructExpression& s)
{
  const class Type* type = s.getNextType ();
  const char* structName = s.getType ()->getName ();

  if (!type) {
    if (structName) {
      thePrinter.printRaw ("too many components for struct ");
      thePrinter.printQuoted (structName);
    }
    else
      thePrinter.printRaw ("too many components for struct");
    thePrinter.finish ();
    return false;
  }

  const char* comp =
    static_cast<const class StructType*>(s.getType ())
    ->getComponentName (s.size ());

  if (!expr) {
    if (structName) {
      thePrinter.printRaw ("error in expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("error in expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    return false;
  }

  if (!expr->getType ()) {
    if (structName) {
      thePrinter.printRaw ("expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.printRaw (" has no type");
    thePrinter.finish ();
    return false;
  }

  if (!makeCompatible (expr, *type))
    return false;

  if (!expr->getType ()->isAlwaysAssignable (*type)) {
    if (Type::isCompatible (*expr->getType (), *type))
      thePrinter.printRaw ("too broad type for struct ");
    else
      thePrinter.printRaw ("type mismatch for struct ");
    if (structName) {
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    return false;
  }
  else if (expr->getType () != type)
    expr = CSE (new class Typecast (*type, *expr));

  return true;
}

static bool
isOrdered (const class Type& type)
{
  if (!type.isOrdered ()) {
    thePrinter.printRaw ("unordered type ");
    printType (type);
    thePrinter.finish ();
    return false;
  }

  return true;
}

static bool
check (const class Valuation& v)
{
  bool ok = true;

  switch (v.getError ()) {
  case errDiv0:
    ok = false, deerror ("division by zero"); break;
  case errOver:
    ok = false, deerror ("overflow"); break;
  case errMod:
    ok = false, deerror ("modulus error"); break;
  case errShift:
    ok = false, deerror ("shift error"); break;
  case errConst:
    ok = false, deerror ("constraint violation"); break;
  case errUnion:
    ok = false, deerror ("union violation"); break;
  case errBuf:
    ok = false, deerror ("buffer violation"); break;
  case errCard:
    ok = false, deerror ("cardinality overflow"); break;
  case errComp:
    assert (false);
  case errNone:
  case errVar:
  case errUndef:
  case errFatal:
    break;
  }

  return ok;
}

static class Expression*
fold (class Expression* expr)
{
  if (expr && expr->isBasic ()) {
    class Valuation v;
    if (class Value* value = expr->eval (v)) {
      assert (v.isOK ());
      expr->destroy ();
      return CSE (new class Constant (*value));
    }
    else {
      if (!check (v)) {
	expr->destroy ();
	return NULL;
      }
      else {
	if (v.getError () == errFatal) {
	  expr->destroy ();
	  return CSE (new class Undefined (Undefined::fFatalError));
	}
	if (v.getError () == errUndef) {
	  expr->destroy ();
	  return CSE (new class Undefined (Undefined::fError));
	}

	assert (v.getError () == errVar);
	return CSE (expr);
      }
    }
  }
  else
    return CSE (expr);
}

static void
defun (const class Type* type,
       char* name,
       class Expression* expr)
{
  currentType = NULL;
  if (type && name && expr) {
    if (net->getFunction (name)) {
      thePrinter.printRaw ("ignoring redefinition of function ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      delete[] name, expr->destroy ();
    }
    else if (isCompatible (expr, type)) {
      class Function* f =
	new class Function (name, currentArity, currentParameters, expr);
      net->addFunction (*f);

      if (dewarnings && net->getType (name)) {
	thePrinter.printRaw ("Warning:function ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows a type name");
	thePrinter.finish ();
	for (unsigned i = 0; i < currentArity; i++) {
	  class VariableSet vars;
	  vars.insert (*currentParameters[i]);
	  if (!expr->depends (vars, false)) {
	    thePrinter.printRaw ("Warning:function ");
	    thePrinter.printQuoted (name);
	    thePrinter.printRaw (" does not use parameter ");
	    thePrinter.printQuoted (currentParameters[i]->getName ());
	    thePrinter.finish ();
	  }
	}
      }
    }
    else
      delete[] name, expr->destroy ();
  }
  else
    delete[] name, expr->destroy ();
  currentArity = 0, currentParameters = 0;
  emptyParsed = false;
}

static class Expression*
newRelopExpression (bool equal,
		    class Expression* left,
		    class Expression* right)
{
  left = ensureExpr (left); right = ensureExpr (right);
  if (!left || !right);
  else if (left->getType () != right->getType ()) {
    if (left->getKind () == Expression::eConstant &&
	makeCompatible (left, *right->getType ()))
      goto ok;
    if (right->getKind () == Expression::eConstant &&
	makeCompatible (right, *left->getType ()))
      goto ok;
    deerror ("expressions in comparison have different types");
  }
  else if (!left->getType ()->isOrdered () && !equal)
    deerror ("cannot compare expressions of unordered type");
  else {
  ok:
    return fold (RelopExpression::construct (equal, *left, *right));
  }

  left->destroy ();
  right->destroy ();
  return 0;
}

static class Expression*
newBinopExpression (enum BinopExpression::Op op,
		    class Expression* left,
		    class Expression* right)
{
  if (left && left->getType () &&
      left->getType ()->getKind () == Type::tVector) {
    bool shl = false;
    switch (op) {
    case BinopExpression::bRol:
      shl = true;
      break;
    case BinopExpression::bRor:
      shl = false;
      break;
    default:
      ensureIntCard (left)->destroy ();
      ensureIntCard (right)->destroy ();
      return NULL;
    }
    if ((left = ensureExpr (left)) && (right = ensureCard (right))) {
      size_t size =
	static_cast<const class VectorType*>(left->getType ())->getSize ();

      if (shl ||
	  (right = fold (new class BinopExpression
			  (BinopExpression::bMinus,
			   *new class Constant (*new class LeafValue
						(Net::getCardType (),
						 card_t (size))), *right)))) {
	if (right->getKind () == Expression::eConstant) {
	  const class Value& v =
	    static_cast<class Constant*>(right)->getValue ();
	  assert (v.getKind () == Value::vLeaf);
	  card_t amount = static_cast<const class LeafValue&>(v);
	  if (!(amount %= size)) {
	    right->destroy ();
	    return left;
	  }
	}
	return fold (new class VectorShift (*left, *right));
      }
    }
    left->destroy (), right->destroy ();
    return NULL;
  }

  left = ensureIntCard (left);
  right = ensureIntCard (right);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (!(right = left->getType ()->getKind () == Type::tCard
	? ensureCard (right) : ensureInt (right))) {
    left->destroy ();
    return NULL;
  }

  return fold (new class BinopExpression (op, *left, *right));
}

static class Expression*
newNotExpression (class Expression* expr)
{
  if ((expr = ensureBool (expr)))
    expr = fold (NotExpression::construct (*expr));
  return expr;
}

static class Expression*
newBooleanBinop (bool conj,
		 class Expression* left,
		 class Expression* right)
{
  assert (left && right);
  assert (left->getKind () == Expression::eUndefined ||
	  (left->getType () && left->getType ()->getKind () == Type::tBool));
  assert (right->getKind () == Expression::eUndefined ||
	  (right->getType () && right->getType ()->getKind () == Type::tBool));
  const class Value* v;
  bool value;
  assert (left == CSE (left));
  assert (right == CSE (right));

  if (left->getKind () == Expression::eConstant) {
    v = &static_cast<class Constant*>(left)->getValue ();
    left->destroy ();
    assert (v && v->getKind () == Value::vLeaf);
    value = bool (static_cast<const class LeafValue&>(*v));

    if (conj) {
      if (value)
	return right;
      else {
	right->destroy ();
      False:
	dewarn ("subexpression is always false");
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), false)));
      }
    }
    else {
      if (value) {
	right->destroy ();
      True:
	dewarn ("subexpression is always true");
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
      }
      else
	return right;
    }
  }
  else if (right->getKind () == Expression::eConstant) {
    v = &static_cast<class Constant*>(right)->getValue ();
    right->destroy ();
    assert (v && v->getKind () == Value::vLeaf);
    value = bool (static_cast<const class LeafValue&>(*v));

    if (conj) {
      if (value)
	return left;
      else {
	left->destroy ();
	goto False;
      }
    }
    else {
      if (value) {
	left->destroy ();
	goto True;
      }
      else
	return left;
    }
  }
  else
    return CSE (BooleanBinop::construct (conj, *left, *right));

  assert (false);
  return NULL;
}

static class Expression*
newSetExpression (enum SetExpression::Op op,
		  class Expression* left,
		  class Expression* right)
{
  const class Type* type = 0;
  if (right && right->isSet ())
    type = right->getType ();
  else if (left && left->isSet ())
    type = left->getType ();
  left = ensureSet (left, type);
  right = ensureSet (right, type);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (left->getKind () == Expression::eEmptySet) {
    if (right->getKind () == Expression::eEmptySet) {
    Same:
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
      case SetExpression::sUnion:
	right->destroy ();
	return left;
      case SetExpression::sSubset:
      case SetExpression::sEquals:
      True:
	left->destroy (), right->destroy ();
	return CSE (new class Constant
		    (*new class LeafValue (Net::getBoolType (), true)));
      }
      assert (false);
    }
    else {
      assert (!!right->getType ());
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
	right->destroy ();
	return left;
      case SetExpression::sUnion:
	left->destroy ();
	return right;
      case SetExpression::sSubset:
	goto True;
      case SetExpression::sEquals:
	goto Compatible;
      }
    }
  }
  else if (right->getKind () == Expression::eEmptySet) {
    switch (op) {
    case SetExpression::sIntersection:
      left->destroy ();
      return right;
    case SetExpression::sMinus:
    case SetExpression::sUnion:
      right->destroy ();
      return left;
    case SetExpression::sSubset:
      op = SetExpression::sEquals;
    case SetExpression::sEquals:
      { class Expression* e = left; left = right; right = e; }
      goto Compatible;
    }
  }

  if (left == right)
    goto Same;

  if (left->getType () == right->getType ()) {
  Compatible:
    return CSE (new class SetExpression (op, *left, *right));
  }
  else {
    deerror ("expressions have incompatible types");
    left->destroy (), right->destroy ();
    return NULL;
  }
}

static class Expression*
newCardinalityExpression (enum CardinalityExpression::Op op,
			  class Expression* expr)
{
  if (class Expression* m = ensureSet (expr)) {
    if (m->getKind () == Expression::eEmptySet) {
      m->destroy ();
      dewarn ("the cardinality of an empty set is always zero");
      return CSE (new class Constant (*new class LeafValue
				      (Net::getCardType (),
				       op == CardinalityExpression::cMin
				       ? CARD_T_MAX
				       : 0)));
    }
    else
      return CSE (new class CardinalityExpression (op, *m));
  }
  else
    return NULL;
}

static class Expression*
newBufferUnop (enum BufferUnop::Op op, class Expression* expr)
{
  if (!(expr = ensureBuffer (expr)))
    return NULL;

  if (expr->getKind () == Expression::eBufferIndex) {
    class BufferIndex* b = static_cast<class BufferIndex*>(expr);
    class Expression* buffer = &b->getBuffer ();
    class Expression* index = &b->getIndex ();
    b->destroy ();
    switch (op) {
    case BufferUnop::bFree:
    case BufferUnop::bUsed:
      if (index) {
	dewarn ("ignoring meaningless buffer indexing expression");
	index->destroy (), index = NULL;
      }
      break;
    case BufferUnop::bPeek:
      break;
    }

    return fold (new class BufferUnop (op, *buffer, index));
  }

  return fold (new class BufferUnop (op, *expr, NULL));
}
